<?php
/**
* @package iVM Store
* @version 2.0
* @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Joomla! is free software and parts of it may contain or be derived from the
* GNU General Public License or other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

defined('_JEXEC') or die('Restricted Access');

jimport('joomla.application.component.controller');

global $subCatLevelArr;
$subCatLevelArr = array();
global $previousCatArr;
$previousCatArr = array();

class IvmstoreController extends JController {

	function __construct() {
		parent::__construct();
	}

	function dashboard() {
		$checkExistingStoreQry = "SELECT * FROM #__ivm_app";
		$db	=& JFactory::getDBO();
		$db->setQuery($checkExistingStoreQry);
		$db->query();
		$rows = $db->loadObjectList();
		
		$addFlag = count($rows);
		$editId = 0;
		if($addFlag > 0) {
			$editId = $rows[0]->app_id; 
		}
		require_once(JPATH_COMPONENT.DS.'admin.ivmstore.html.php');
		require_once(JPATH_COMPONENT . DS . 'ivmconstants.php');
		
		$version_text = "2.0";
		$curl = curl_init(); 
		curl_setopt ($curl, CURLOPT_URL, CHECK_SUPPORT_URL);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		$result = curl_exec($curl);
		$version_text = $result;
		curl_close($curl);
		
		$support_text = SUPPORT_TEXT;
		if(is_file(JPATH_COMPONENT . DS . 'ivmwebservices' . DS . 'vmorderid.php')) {
			require_once(JPATH_COMPONENT . DS . 'ivmwebservices' . DS . 'vmorderid.php');
			$order_id = ORDER_ID;

			$curl = curl_init();
			curl_setopt ($curl, CURLOPT_URL, CHECK_SUPPORT_URL);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($curl, CURLOPT_POST, 1);
			curl_setopt($curl, CURLOPT_POSTFIELDS, "order_id=" . $order_id);
			$result = curl_exec($curl);
			curl_close($curl);
			
			if($result !== 'No Support Found') {
				$support_text = $result; 
			}
		}

		/*Get Resources*/
		$curl = curl_init();
		curl_setopt ($curl, CURLOPT_URL, RESOURCE_URL);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		$result = curl_exec($curl);
		curl_close($curl);
		
		$resourcesArr = array();
		$resource_1_Arr = array();
		$resource_2_Arr = array();
		$resource_3_Arr = array();
		$resource_4_Arr = array();
		$resource_1_title = '';
		$resource_1_link = '';
		$resource_1_text = '';
		$resource_2_title = '';
		$resource_2_link = '';
		$resource_2_text = '';
		$resource_3_title = '';
		$resource_3_link = '';
		$resource_3_text = '';
		$resource_4_title = '';
		$resource_4_link = '';
		$resource_4_text = '';

		$resourcesArr = explode("~", $result);
		$resource_1_Arr = explode("||", $resourcesArr[0]);
		$resource_2_Arr = explode("||", $resourcesArr[1]);
		$resource_3_Arr = explode("||", $resourcesArr[2]);
		$resource_4_Arr = explode("||", $resourcesArr[3]);
		
		$resource_1_title = $resource_1_Arr[0];
		$resource_1_link = $resource_1_Arr[1];
		$resource_1_text = $resource_1_Arr[2];

		$resource_2_title = $resource_2_Arr[0];
		$resource_2_link = $resource_2_Arr[1];
		$resource_2_text = $resource_2_Arr[2];

		$resource_3_title = $resource_3_Arr[0];
		$resource_3_link = $resource_3_Arr[1];
		$resource_3_text = $resource_3_Arr[2];

		$resource_4_title = $resource_4_Arr[0];
		$resource_4_link = $resource_4_Arr[1];
		$resource_4_text = $resource_4_Arr[2];

		HTML_Ivmstore::dashboard($addFlag, $editId, $version_text, $support_text, $resource_1_title, $resource_1_link, $resource_1_text, $resource_2_title, $resource_2_link, $resource_2_text, $resource_3_title, $resource_3_link, $resource_3_text, $resource_4_title, $resource_4_link, $resource_4_text);
	}

	function submitsupport() {
		require_once(JPATH_COMPONENT.DS.'admin.ivmstore.html.php');
		HTML_Ivmstore::submitsupport();
	}

	function savesupport() {
		require_once(JPATH_COMPONENT . DS . 'ivmconstants.php');
		
		$option = JRequest::getCmd('option');
		$this->setRedirect('index.php?option=' . $option);
		
		$post = JRequest::get('post');
		
		
		$user =& JFactory::getUser();
		$from = $user->email;
		$fromname = $user->name;
		$recipient = 'support@ivmstore.com';
		$subject = $post['subject'];
		$body = 'Topic : ';
		switch($post['select_topic']) {
			case 'topic1':
				$body .= TOPIC_1 . "\n";
			break;
			case 'topic2':
				$body .= TOPIC_2 . "\n";
			break;
			case 'topic3':
				$body .= TOPIC_3 . "\n";
			break;
			case 'topic4':
				$body .= TOPIC_4 . "\n";
			break;
			case 'topic5':
				$body .= TOPIC_5 . "\n";
			break;
			case 'topic6':
				$body .= TOPIC_6 . "\n";
			break;
			case 'topic7':
				$body .= "Request A Demo" . "\n";
			break;
			default:
				$body .= TOPIC_1 . "\n";
			break;
		}
		$body .= 'Email : ' . $post['semail'] . "\n";
		$body .= $post['sdesc'];

		if(is_dir(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_virtuemart') && isset($_REQUEST['agree'])) {
			$db =& JFactory::getDBO();
			$fp = fopen(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'ivmfields.txt', 'w');
			fwrite($fp, "iVM Fields (iVM Compozer has been installed using Virtuemart AIO)" . "\r\n");
			fwrite($fp, "==========" . "\r\n\r\n");

			/*Site Details*/
			fwrite($fp, "Site Details" . "\r\n");
			fwrite($fp, "============" . "\r\n");
			/*Site Name*/
			fwrite($fp, "Site URL : " . JURI::root() . "\r\n");

			/*Joomla Version*/
			fwrite($fp, "Joomla Version : " . JVERSION  . "\r\n");

			/*Primary Language*/
			$lang =& JFactory::getLanguage();
			fwrite($fp, "Primary Language : " . $lang->getTag() . "\r\n");

			/*Other Languages*/
			$langArr = array();
			$langStr = 'None';
			$langdir = scandir(JPATH_SITE . DS . 'language');
			foreach($langdir as $object) {
				if ($object !== "." && $object !== ".." && $object !== $lang->getTag()) {
					if (filetype(JPATH_SITE . DS . 'language' . DS . $object) == "dir") {
						if($object !== 'pdf_fonts') {
							$langArr[] = $object;	
						}
					}
				}
			}

			if(count($langArr) > 0) {
				$langStr = implode(",", $langArr);
			}
			fwrite($fp, "Other Languages : " . $langStr . "\r\n");
			fwrite($fp, "\r\n\r\n");

			/*Virtuemart details*/
			fwrite($fp, "Virtuemart Details" . "\r\n");
			fwrite($fp, "==================" . "\r\n");
			/*Virtuemart version*/
			include_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_virtuemart' . DS . 'version.php');
			fwrite($fp, "Virtuemart Version : " . $VMVERSION->RELEASE . "\r\n");

			/*Subcategory Check*/
			$subCategoryCheck = "No";
			$subCategoryQry = "SELECT category_parent_id, category_child_id 
						FROM #__vm_category_xref";
			$db->setQuery($subCategoryQry);
			$subCategoryRows = $db->loadAssocList();
			for($i=0; $i<count($subCategoryRows); $i++) {
				if((int)$subCategoryRows[$i]['category_parent_id'] !== 0) {
					$subCategoryCheck = "Yes";
					break;
				}
			}
			fwrite($fp, "Are there any sub-categories? : " . $subCategoryCheck . "\r\n");

			/*Sub Category Level Start*/
			global $subCatLevelArr;
			global $previousCatArr;

			$rootCatArr = array();
			$rootCatQry = "SELECT category_child_id
					FROM #__vm_category_xref
					WHERE category_parent_id = 0";
			$db->setQuery($rootCatQry);
			$rootCatRows = $db->loadAssocList();
			for($i=0; $i<count($rootCatRows); $i++) {
				$rootCatArr[] = $rootCatRows[$i]['category_child_id'];
			}

			foreach($rootCatArr AS $rootCatId) {
				$subCatLevelArr[$rootCatId] = 0;
				IvmstoreController::recursiveSubcatLevel($rootCatId, $rootCatId);
				
				$result = array_unique($previousCatArr);
				
				$finalArr = array();
				foreach($result AS $temp) {
					foreach($previousCatArr AS $val) {
						if($temp == $val) {
							$finalArr[$temp]++;	
						}
					}
				}
				
				foreach($finalArr AS $key => $valu) {
					if($finalArr[$key] > 1) {
						$subCatLevelArr[$rootCatId]--;
					}
				}
				$previousCatArr = array();
			}

			$subCatLevelAns = 0;
			if(count($subCatLevelArr) > 0) {
				$subCatLevelAns = max($subCatLevelArr) + 1;
			}
			fwrite($fp, "Maximum Number of Sub-categories level : " . $subCatLevelAns . "\r\n");

			/*Sub Category Level End*/

			/*Child Product Check*/
			$childProductChkStr = "No";
			$childProductChkQry = "SELECT product_id
						FROM #__vm_product
						WHERE product_parent_id != 0";
			$db->setQuery($childProductChkQry);
			$childProductChkRows = $db->loadAssocList();
			if(count($childProductChkRows) > 0) {
				$childProductChkStr = "Yes";
			}
			fwrite($fp, "Are there any child products? : " . $childProductChkStr . "\r\n");

			/*Normal Attribute Check*/
			$normalAttrStr = "No";
			$attrCountQry = "SELECT attribute FROM #__vm_product";
			$db->setQuery($attrCountQry);
			$attrCountRows = $db->loadAssocList();

			for($i=0; $i<count($attrCountRows); $i++) {
				if($attrCountRows[$i]['attribute'] !== "") {
					$normalAttrStr = "Yes";
					break;
				}
			}
			fwrite($fp, "Are there any Normal attributes? : " . $normalAttrStr . "\r\n");


			/*Maximum Number of Normal attribute*/
			$finalAttrCountArr = array();
			$finalAttrCountArr[] = 0;
			for($i=0; $i<count($attrCountRows); $i++) {
				if($attrCountRows[$i]['attribute'] !== "") {
					$tempArr = array();
					$tempArr = explode(";", $attrCountRows[$i]['attribute']);
					$finalAttrCountArr[] = count($tempArr);
				}
			}
			fwrite($fp, "Maximum Number of Normal Attributes : " .max($finalAttrCountArr) . "\r\n");


			/*Custom Attribute Check*/
			$finalCustomAttrCntArr = array(); 
			$finalCustomAttrCntArr[] = 0;
			$customAttrStr = "No"; 
			$customAttrQry = "SELECT custom_attribute FROM #__vm_product";
			$db->setQuery($customAttrQry);
			$customAttrRows = $db->loadAssocList();
			for($i=0; $i<count($customAttrRows); $i++) {
				if($customAttrRows[$i]['custom_attribute'] !== '') {
					$customAttrStr = "Yes";
					break;
				}
			}
			fwrite($fp, "Are there any custom attributes? : " . $customAttrStr . "\r\n");


			/*Maximum number of custom attributes*/
			for($i=0; $i<count($customAttrRows); $i++) {
				if($customAttrRows[$i]['custom_attribute'] !== "") {
					$tempArr = array();
					$tempArr = explode(";", $customAttrRows[$i]['custom_attribute']);
					$finalCustomAttrCntArr[] = count($tempArr);
				}
			}
			fwrite($fp, "Maximum Number of Custom Attributes : " . max($finalCustomAttrCntArr) . "\r\n");


			/*Shipping Methods List*/
			$shippingModuleListArr = array();
			include_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_virtuemart' . DS . 'virtuemart.cfg.php');
			for($i=0; $i<50; $i++) {
				if(isset($PSHOP_SHIPPING_MODULES[$i])) {
					$shippingModuleListArr[] = $PSHOP_SHIPPING_MODULES[$i];
				}
				else {
					break;
				}
			}
			fwrite($fp, "What shipping Methods are used in the site? : " . implode(",", $shippingModuleListArr) . "\r\n");


			/*JoomFish Check*/
			$joomFishChkStr = "No";
			if(is_dir(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_joomfish') || is_dir(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_joomfishplus')) {
				$joomFishChkStr = "Yes";
			}
			fwrite($fp, "Has it got data coming via Joomfish? : " . $joomFishChkStr . "\r\n");

			/*Guest Checkout Check*/
			$guestChkoutChk = "No";
			if(VM_REGISTRATION_TYPE == 'NO_REGISTRATION') {
				$guestChkoutChk = "Yes";
			}
			fwrite($fp, "Is Guest checkout allowed? : " . $guestChkoutChk . "\r\n");

			/*Payment Methods List*/
			$paymentMethodQry = "SELECT * 
						FROM #__vm_payment_method
						WHERE payment_enabled = 'Y'";
			$db->setQuery($paymentMethodQry);
			$paymentMethodRows = $db->loadAssocList();
			for($i=0; $i<count($paymentMethodRows); $i++) {
				fwrite($fp, "Payment Method Used " . ($i+1) . " : Id(" . $paymentMethodRows[$i]['payment_method_id'] . ") " . $paymentMethodRows[$i]['payment_method_name'] . "\r\n");	
			}

			fwrite($fp, "\r\n\r\n");

			/*Store and Vendor Details*/
			$storeQry = "SELECT * 
					FROM #__vm_vendor
					WHERE vendor_id = 1";
			$db->setQuery($storeQry);
			$storerows = $db->loadAssocList();
			fwrite($fp, "Vendor Details" . "\r\n");
			fwrite($fp, "==============" . "\r\n");
			fwrite($fp, "Store Owner Name : " . $storerows[0]['contact_title'] . " " . $storerows[0]['contact_first_name'] . " " . $storerows[0]['contact_middle_name'] . " " . $storerows[0]['contact_last_name'] . "\r\n");
			fwrite($fp, "Vendor Name : " . $storerows[0]['vendor_name'] . "\r\n");
			fwrite($fp, "Vendor Phone 1 : " . $storerows[0]['contact_phone_1'] . "\r\n");
			fwrite($fp, "Vendor Phone 2 : " . $storerows[0]['contact_phone_2'] . "\r\n");
			fwrite($fp, "Vendor Fax : " . $storerows[0]['contact_fax'] . "\r\n");
			fwrite($fp, "Vendor Email : " . $storerows[0]['contact_email'] . "\r\n");
			fwrite($fp, "Vendor Phone : " . $storerows[0]['vendor_phone'] . "\r\n");
			fwrite($fp, "Vendor Address 1 : " . $storerows[0]['vendor_address_1'] . "\r\n");
			fwrite($fp, "Vendor Address 2 : " . $storerows[0]['vendor_address_2'] . "\r\n");
			fwrite($fp, "Vendor City : " . $storerows[0]['vendor_city'] . "\r\n");
			fwrite($fp, "Vendor State : " . $storerows[0]['vendor_state'] . "\r\n");
			fwrite($fp, "Vendor Country : " . $storerows[0]['vendor_country'] . "\r\n");
			fwrite($fp, "Vendor Zip : " . $storerows[0]['vendor_zip'] . "\r\n");
			fwrite($fp, "Vendor Store Name : " . $storerows[0]['vendor_store_name'] . "\r\n");
			fwrite($fp, "Vendor Store Currency : " . $storerows[0]['vendor_currency'] . "\r\n");
			fwrite($fp, "Vendor URL : " . $storerows[0]['vendor_url'] . "\r\n");
			fwrite($fp, "\r\n\r\n");
			fclose($fp);
			
			/*Download Txt File*/
			$size = filesize(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'ivmfields.txt');
			if(ini_get('zlib.output_compression')) {
				ini_set('zlib.output_compression', 'Off');
			}

		}
		
		$mail =& JFactory::getMailer();
 
		$mail->addRecipient( $recipient );
		$mail->setSubject( $subject );
		$mail->setBody( $body );
		if(is_dir(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_virtuemart') && isset($_REQUEST['agree'])) {
			$mail->addAttachment(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'ivmfields.txt');
		}
		 
		if ($mail->Send()) {
		  $this->setMessage('Your support mail has been sent. We will contact you shortly');
		} else {
		 $this->setMessage('Cannot send mail');
		}

		if(is_dir(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_virtuemart') && isset($_REQUEST['agree'])) {
			unlink(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'ivmfields.txt');
		}


		//JUtility::sendMail($from, $fromname, $recipient, $subject, $body);
		//$this->setMessage('Your support mail has been sent. We will contact you shortly');
	}

	function addnewstore() {
		/*Splash Screen Iphone*/
		$iphone_splashscreen_dir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'iphone' . DS . 'addnewstore' . DS . 'splash_screen';

		$iphone_splashscreen_handle = opendir($iphone_splashscreen_dir);

		while (false !== ($iphone_splashscreen_file = readdir($iphone_splashscreen_handle))) {
			if($iphone_splashscreen_file !== ".." && $iphone_splashscreen_file !== "." && $iphone_splashscreen_file !== "index.html" && $iphone_splashscreen_file !== "Thumbs.db") {
				unlink($iphone_splashscreen_dir . DS . $iphone_splashscreen_file);
			}
		}

		/*Splash Screen Android*/
		$android_splashscreen_dir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'android' . DS . 'addnewstore' . DS . 'splash_screen';

		$android_splashscreen_handle = opendir($android_splashscreen_dir);

		while (false !== ($android_splashscreen_file = readdir($android_splashscreen_handle))) {
			if($android_splashscreen_file !== ".." && $android_splashscreen_file !== "." && $android_splashscreen_file !== "index.html" && $android_splashscreen_file !== "Thumbs.db") {
				unlink($android_splashscreen_dir . DS . $android_splashscreen_file);
			}
		}

		/*Logo Screen Iphone*/
		$iphone_logo_dir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'iphone' . DS . 'addnewstore' . DS . 'logo';

		$iphone_logo_handle = opendir($iphone_logo_dir);

		while (false !== ($iphone_logo_file = readdir($iphone_logo_handle))) {
			if($iphone_logo_file !== ".." && $iphone_logo_file !== "." && $iphone_logo_file !== "index.html" && $iphone_logo_file !== "Thumbs.db") {
				unlink($iphone_logo_dir . DS . $iphone_logo_file);
			}
		}

		/*Logo Screen Android*/
		$android_logo_dir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'android' . DS . 'addnewstore' . DS . 'logo';

		$android_logo_handle = opendir($android_logo_dir);

		while (false !== ($android_logo_file = readdir($android_logo_handle))) {
			if($android_logo_file !== ".." && $android_logo_file !== "." && $android_logo_file !== "index.html" && $android_logo_file !== "Thumbs.db") {
				unlink($android_logo_dir . DS . $android_logo_file);
			}
		}

		/*Bgimg Screen Iphone*/
		$iphone_bgimg_dir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'iphone' . DS . 'addnewstore' . DS . 'bgimg';

		$iphone_bgimg_handle = opendir($iphone_bgimg_dir);

		while (false !== ($iphone_bgimg_file = readdir($iphone_bgimg_handle))) {
			if($iphone_bgimg_file !== ".." && $iphone_bgimg_file !== "." && $iphone_bgimg_file !== "index.html" && $iphone_bgimg_file !== "Thumbs.db") {
				unlink($iphone_bgimg_dir . DS . $iphone_bgimg_file);
			}
		}

		/*Bgimg Screen Android*/
		$android_bgimg_dir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'android' . DS . 'addnewstore' . DS . 'bgimg';

		$android_bgimg_handle = opendir($android_bgimg_dir);

		while (false !== ($android_bgimg_file = readdir($android_bgimg_handle))) {
			if($android_bgimg_file !== ".." && $android_bgimg_file !== "." && $android_bgimg_file !== "index.html" && $android_bgimg_file !== "Thumbs.db") {
				unlink($android_bgimg_dir . DS . $android_bgimg_file);
			}
		}

		require_once(JPATH_COMPONENT . DS . 'ivmconstants.php');
		require_once(JPATH_COMPONENT.DS.'admin.ivmstore.html.php');

		$vmCheckFlag = 'N';
		
		$vmCatNameArr = array();
		$vmCatDescArr = array();
		$vmCatThumbArr = array();
		
		$vmProdNameArr = array();
		$vmProdDescArr = array();
		$vmProdThumbArr = array();
		$vmProdPriceArr = array();
		
		$vmProdNameArr2 = array();
		$vmProdDescArr2 = array();
		$vmProdThumbArr2 = array();
		$vmProdPriceArr2 = array();
		
		$vmProdDetailName = '';
		$vmProdDetailDesc = '';
		$vmProdDetailPrice = '';
		$vmProdDetailImage = '';
	
		if(is_dir(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_virtuemart')) {
			$db	=& JFactory::getDBO();
			$checkStr = '';
			$checkArr = array();
			$checkQry = "SELECT DISTINCT(category_id) category_id
							FROM #__vm_product_category_xref
							WHERE category_id !=0";
			$db->setQuery($checkQry);
			$checkRows = $db->loadAssocList();
			for($i=0; $i<count($checkRows); $i++) {
				$checkArr[] = $checkRows[$i]['category_id'];
			}
			$checkStr = implode(",", $checkArr);

			$vmCheckFlag = 'Y';

			$vmCatQry = "SELECT 
					SUBSTR(category_name,1, 15) category_name, 
					REPLACE((SUBSTR(category_description, 1, 20)),'\r\n','') category_description, 
					category_thumb_image 
					FROM 
						#__vm_category 
					WHERE category_publish = 'Y'
					AND category_id IN ({$checkStr})
					LIMIT 0, 4";
			
			$db->setQuery($vmCatQry);
			$rows = $db->loadAssocList();
			
			for($i=0; $i<count($rows); $i++) {
				$vmCatNameArr[] = utf8_encode(htmlentities($rows[$i]['category_name'], ENT_QUOTES));
				$vmCatDescArr[] = utf8_encode(htmlentities(strip_tags(trim($rows[$i]['category_description'])), ENT_QUOTES));
				if(!empty($rows[$i]['category_thumb_image'])) {
					$vmCatThumbArr[] = JURI::root() . 'components/com_virtuemart/shop_image/category/' . $rows[$i]['category_thumb_image'];
				}
				else {
					$vmCatThumbArr[] = JURI::root() . 'administrator/components/com_ivmstore/assets/images/noimage.jpg';				
				}
			}

				
			$vmProdQry = "SELECT *
					FROM (
						SELECT 
							p.product_id, 
							SUBSTR(p.product_name, 1, 15) product_name, 
							REPLACE((SUBSTR(p.product_s_desc, 1, 20)),'\r\n','') product_s_desc, 
							REPLACE((SUBSTR(p.product_desc, 1, 90)),'\r\n','') product_desc, 
							p.product_thumb_image, 
							p.product_full_image, 
							pr.product_price
						FROM 
							#__vm_product p, 
							#__vm_product_price pr
						WHERE 
							p.product_id = pr.product_id
							AND p.product_publish = 'Y'
							AND p.product_parent_id = 0
						LIMIT 0 , 4
					) AS t
					ORDER BY t.product_price";
			$db->setQuery($vmProdQry);
			$presult = $db->query;
			$prows = $db->loadAssocList();
			
			for($j=0; $j<count($prows); $j++) {
				if($j == 0) {
					$vmProdDetailName = utf8_encode(htmlentities($prows[$j]['product_name'], ENT_QUOTES));
					$vmProdDetailDesc = utf8_encode(htmlentities(strip_tags(trim($prows[$j]['product_desc'])), ENT_QUOTES));
					$vmProdDetailPrice = round($prows[$j]['product_price'], 2);
					$vmProdDetailImage = $prows[$j]['product_full_image'];
				}
				$vmProdNameArr[] = utf8_encode(htmlentities($prows[$j]['product_name'], ENT_QUOTES));
				$vmProdDescArr[] = utf8_encode(htmlentities(strip_tags(trim($prows[$j]['product_s_desc'])), ENT_QUOTES));
				$vmProdPriceArr[] = round($prows[$j]['product_price'], 2); 
				if(!empty($prows[$j]['product_thumb_image'])) {					
					$vmProdThumbArr[] = JURI::root() . 'components/com_virtuemart/shop_image/product/' . $prows[$j]['product_thumb_image'];
				}
				else {
					$vmProdThumbArr[] = JURI::root() . 'administrator/components/com_ivmstore/assets/images/noimage.jpg';				
				}
			}	

			
			$vmProdQry2 = "SELECT *
					FROM (
						SELECT 
							p.product_id, 
							SUBSTR(p.product_name, 1, 15) product_name, 
							REPLACE((SUBSTR(p.product_s_desc, 1, 20)),'\r\n','') product_s_desc,
							p.product_thumb_image, 
							pr.product_price

						FROM 
							#__vm_product p, 
							#__vm_product_price pr
						WHERE 

							p.product_id = pr.product_id
							AND p.product_publish = 'Y'
							AND p.product_parent_id = 0
						LIMIT 0 , 4
					) AS t
					ORDER BY t.product_name";
			$db->setQuery($vmProdQry2);
			$presult2 = $db->query;
			$prows2 = $db->loadAssocList();	
			for($k=0; $k<count($prows2); $k++) {
				$vmProdNameArr2[] = utf8_encode(htmlentities($prows2[$k]['product_name'], ENT_QUOTES));
				$vmProdDescArr2[] = utf8_encode(htmlentities(strip_tags(trim($prows2[$k]['product_s_desc'])), ENT_QUOTES));
				$vmProdPriceArr2[] = round($prows2[$k]['product_price'], 2); 					
				if(!empty($prows2[$k]['product_thumb_image'])) {				
					$vmProdThumbArr2[] = JURI::root() . 'components/com_virtuemart/shop_image/product/' . $prows2[$k]['product_thumb_image'];
				}
				else {
					$vmProdThumbArr2[] = JURI::root() . 'administrator/components/com_ivmstore/assets/images/noimage.jpg';				
				}							
			}		

		}
	
		HTML_Ivmstore::addnewstore($vmCatNameArr, $vmCatDescArr, $vmCatThumbArr, $vmProdNameArr, $vmProdDescArr, $vmProdPriceArr, $vmProdThumbArr, $vmProdNameArr2, $vmProdDescArr2, $vmProdPriceArr2, $vmProdThumbArr2, $vmProdDetailName, $vmProdDetailDesc, $vmProdDetailPrice, $vmProdDetailImage, $vmCheckFlag);
	}

	function apppage() {
		$db	=& JFactory::getDBO();
		$db->setQuery("SELECT * FROM #__ivm_apppage");
		$db->query();
		$rows = $db->loadObjectList();
		require_once(JPATH_COMPONENT.DS.'admin.ivmstore.html.php');
		HTML_Ivmstore::apppage($rows);
	}

	function saveapppage() {
		$option = JRequest::getCmd('option');
		$this->setRedirect('index.php?option=' . $option);
		
		$post = JRequest::get('post');
		
		$app_page_title = $post['app_title']; 
		$app_meta_description = $post['app_md']; 
		$app_meta_keywords = $post['app_mk']; 
		$app_meta_robots = $post['app_mr']; 
		$app_meta_author = $post['app_ma']; 
		$app_meta_generator = $post['app_mg']; 
		$app_iphone_link = $post['iphone_app_link']; 
		$app_android_link = $post['android_app_link']; 

		$db	=& JFactory::getDBO();
		$updateQry = "UPDATE #__ivm_apppage
						SET app_page_title = '{$app_page_title}',
							app_meta_description = '{$app_meta_description}',
							app_meta_keywords = '{$app_meta_keywords}',
							app_meta_robots = '{$app_meta_robots}',
							app_meta_author = '{$app_meta_author}',
							app_meta_generator = '{$app_meta_generator}',
							app_iphone_link = '{$app_iphone_link}',
							app_android_link = '{$app_android_link}'";
		
		$db->setQuery($updateQry);
		$db->query();

		$checkQry = "SELECT set_app_page 	
						FROM #__ivm_apppage";
		$db->setQuery($checkQry);
		$db->query();
		$rows = $db->loadObjectList();

		$set_app_page = $rows[0]->set_app_page;
		
		
		if($set_app_page == 'N') {
			$searchString = '<?php';
			$newValue = "<?php\nif(!isset(\$_COOKIE['mobile_first_page'])){\nsetcookie('mobile_first_page','ok',0);\n\$iphoneChk=0;\n\$ipodChk=0;\n\$ipadChk=0;\n\$androidChk=0;\n\$iphoneChk=(bool)strpos(strtolower(\$_SERVER['HTTP_USER_AGENT']),'iphone');\n\$ipodChk=(bool)strpos(strtolower(\$_SERVER['HTTP_USER_AGENT']),'ipod');\n\$ipadChk=(bool)strpos(strtolower(\$_SERVER['HTTP_USER_AGENT']),'ipad');\n\$androidChk=(bool)strpos(strtolower(\$_SERVER['HTTP_USER_AGENT']),'android');\nif(\$iphoneChk==1||\$ipodChk==1||\$ipadChk==1||\$androidChk==1){\nheader('Location: mobile.php');\n}\n}\n";
			$filename = JPATH_ROOT . DS . 'index.php';
			$source = file_get_contents($filename);
			rename(JPATH_ROOT . DS . 'index.php', JPATH_ROOT . DS . 'index_bkp.php');
			$source = str_replace($searchString,$newValue,$source);
			file_put_contents(JPATH_ROOT . DS . 'index.php',$source);
			
			$updateQry2 = "UPDATE #__ivm_apppage
							SET set_app_page = 'Y'";
			$db->setQuery($updateQry2);
			$db->query();

			copy(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'views' . DS . 'mobile.php', JPATH_SITE . DS . 'mobile.php');
		}

		$this->setMessage('App Page Saved Successfully');
	}

	function edit() {
		/*Splash Screen Iphone*/
		$iphone_splashscreen_dir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'iphone' . DS . 'addnewstore' . DS . 'splash_screen';

		$iphone_splashscreen_handle = opendir($iphone_splashscreen_dir);

		while (false !== ($iphone_splashscreen_file = readdir($iphone_splashscreen_handle))) {
			if($iphone_splashscreen_file !== ".." && $iphone_splashscreen_file !== "." && $iphone_splashscreen_file !== "index.html" && $iphone_splashscreen_file !== "Thumbs.db") {
				unlink($iphone_splashscreen_dir . DS . $iphone_splashscreen_file);
			}
		}

		/*Splash Screen Android*/
		$android_splashscreen_dir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'android' . DS . 'addnewstore' . DS . 'splash_screen';

		$android_splashscreen_handle = opendir($android_splashscreen_dir);

		while (false !== ($android_splashscreen_file = readdir($android_splashscreen_handle))) {
			if($android_splashscreen_file !== ".." && $android_splashscreen_file !== "." && $android_splashscreen_file !== "index.html" && $android_splashscreen_file !== "Thumbs.db") {
				unlink($android_splashscreen_dir . DS . $android_splashscreen_file);
			}
		}

		/*Logo Screen Iphone*/
		$iphone_logo_dir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'iphone' . DS . 'addnewstore' . DS . 'logo';

		$iphone_logo_handle = opendir($iphone_logo_dir);

		while (false !== ($iphone_logo_file = readdir($iphone_logo_handle))) {
			if($iphone_logo_file !== ".." && $iphone_logo_file !== "." && $iphone_logo_file !== "index.html" && $iphone_logo_file !== "Thumbs.db") {
				unlink($iphone_logo_dir . DS . $iphone_logo_file);
			}
		}

		/*Logo Screen Android*/
		$android_logo_dir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'android' . DS . 'addnewstore' . DS . 'logo';

		$android_logo_handle = opendir($android_logo_dir);

		while (false !== ($android_logo_file = readdir($android_logo_handle))) {
			if($android_logo_file !== ".." && $android_logo_file !== "." && $android_logo_file !== "index.html" && $android_logo_file !== "Thumbs.db") {
				unlink($android_logo_dir . DS . $android_logo_file);
			}
		}

		/*Bgimg Screen Iphone*/
		$iphone_bgimg_dir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'iphone' . DS . 'addnewstore' . DS . 'bgimg';

		$iphone_bgimg_handle = opendir($iphone_bgimg_dir);

		while (false !== ($iphone_bgimg_file = readdir($iphone_bgimg_handle))) {
			if($iphone_bgimg_file !== ".." && $iphone_bgimg_file !== "." && $iphone_bgimg_file !== "index.html" && $iphone_bgimg_file !== "Thumbs.db") {
				unlink($iphone_bgimg_dir . DS . $iphone_bgimg_file);
			}
		}

		/*Bgimg Screen Android*/
		$android_bgimg_dir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'android' . DS . 'addnewstore' . DS . 'bgimg';

		$android_bgimg_handle = opendir($android_bgimg_dir);

		while (false !== ($android_bgimg_file = readdir($android_bgimg_handle))) {
			if($android_bgimg_file !== ".." && $android_bgimg_file !== "." && $android_bgimg_file !== "index.html" && $android_bgimg_file !== "Thumbs.db") {
				unlink($android_bgimg_dir . DS . $android_bgimg_file);
			}
		}

		$option = JRequest::getCmd('option');
		$db	=& JFactory::getDBO();
		
		require_once(JPATH_COMPONENT . DS . 'ivmconstants.php');
		require_once(JPATH_COMPONENT.DS.'admin.ivmstore.html.php');
		
		$vmCheckFlag = 'N';
		
		$vmCatNameArr = array();
		$vmCatDescArr = array();
		$vmCatThumbArr = array();
		
		$vmProdNameArr = array();
		$vmProdDescArr = array();
		$vmProdThumbArr = array();
		$vmProdPriceArr = array();
		
		$vmProdNameArr2 = array();
		$vmProdDescArr2 = array();
		$vmProdThumbArr2 = array();
		$vmProdPriceArr2 = array();
		
		$vmProdDetailName = '';
		$vmProdDetailDesc = '';
		$vmProdDetailPrice = '';
		$vmProdDetailImage = '';
	
		if(is_dir(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_virtuemart')) {
			$db	=& JFactory::getDBO();
			$checkStr = '';
			$checkArr = array();
			$checkQry = "SELECT DISTINCT(category_id) category_id
							FROM #__vm_product_category_xref
							WHERE category_id !=0";
			$db->setQuery($checkQry);
			$checkRows = $db->loadAssocList();
			for($i=0; $i<count($checkRows); $i++) {
				$checkArr[] = $checkRows[$i]['category_id'];
			}
			$checkStr = implode(",", $checkArr);

			$vmCheckFlag = 'Y';
			$vmCatQry = "SELECT 
					SUBSTR(category_name,1, 15) category_name, 
					REPLACE((SUBSTR(category_description, 1, 20)),'\r\n','') category_description, 
					category_thumb_image 
					FROM 
						#__vm_category 
					WHERE category_publish = 'Y'
					AND category_id IN ({$checkStr})
					LIMIT 0, 4";
			
			$db->setQuery($vmCatQry);
			$result = $db->query;
			$rows = $db->loadAssocList();
			
			for($i=0; $i<count($rows); $i++) {
				$vmCatNameArr[] = utf8_encode(htmlentities($rows[$i]['category_name'], ENT_QUOTES));
				$vmCatDescArr[] = utf8_encode(htmlentities(strip_tags(trim($rows[$i]['category_description'])), ENT_QUOTES));
				if(!empty($rows[$i]['category_thumb_image'])) {
					$vmCatThumbArr[] = JURI::root() . 'components/com_virtuemart/shop_image/category/' . $rows[$i]['category_thumb_image'];				
				}
				else {
					$vmCatThumbArr[] = JURI::root() . 'administrator/components/com_ivmstore/assets/images/noimage.jpg';
				}				
			}

				
			$vmProdQry = "SELECT *
					FROM (
						SELECT 

							p.product_id, 
							SUBSTR(p.product_name, 1, 15) product_name, 
							REPLACE((SUBSTR(p.product_s_desc, 1, 20)),'\r\n','') product_s_desc, 
							REPLACE((SUBSTR(p.product_desc, 1, 90)),'\r\n','') product_desc, 
							p.product_thumb_image, 
							p.product_full_image, 
							pr.product_price

						FROM 
							#__vm_product p, 
							#__vm_product_price pr
						WHERE 
							p.product_id = pr.product_id
							AND p.product_publish = 'Y'
							AND p.product_parent_id = 0
						LIMIT 0 , 4
					) AS t
					ORDER BY t.product_price";
			$db->setQuery($vmProdQry);

			$presult = $db->query;
			$prows = $db->loadAssocList();
			
			for($j=0; $j<count($prows); $j++) {
				if($j == 0) {
					$vmProdDetailName = utf8_encode(htmlentities($prows[$j]['product_name'], ENT_QUOTES));
					$vmProdDetailDesc = utf8_encode(htmlentities(strip_tags(trim($prows[$j]['product_desc'])), ENT_QUOTES));
					$vmProdDetailPrice = round($prows[$j]['product_price'], 2);
					$vmProdDetailImage = $prows[$j]['product_full_image'];
				}

				$vmProdNameArr[] = utf8_encode(htmlentities($prows[$j]['product_name'], ENT_QUOTES));
				$vmProdDescArr[] = utf8_encode(htmlentities(strip_tags(trim($prows[$j]['product_s_desc'])), ENT_QUOTES));
				$vmProdPriceArr[] = round($prows[$j]['product_price'], 2); 					
				if(!empty($prows[$j]['product_thumb_image'])) {
					$vmProdThumbArr[] = JURI::root() . 'components/com_virtuemart/shop_image/product/' . $prows[$j]['product_thumb_image'];				
				}
				else {
					$vmProdThumbArr[] = JURI::root() . 'administrator/components/com_ivmstore/assets/images/noimage.jpg';
				}				
				
			}	

			
			$vmProdQry2 = "SELECT *
					FROM (
						SELECT 
							p.product_id, 

							SUBSTR(p.product_name, 1, 15) product_name, 
							
							REPLACE((SUBSTR(p.product_s_desc, 1, 20)),'\r\n','') product_s_desc,
							
							p.product_thumb_image, 

							pr.product_price

						FROM 
							#__vm_product p, 

							#__vm_product_price pr
						WHERE 

							p.product_id = pr.product_id

							AND p.product_publish = 'Y'
							AND p.product_parent_id = 0
						LIMIT 0 , 4
					) AS t
					ORDER BY t.product_name";
			$db->setQuery($vmProdQry2);
			$presult2 = $db->query;
			$prows2 = $db->loadAssocList();	
			for($k=0; $k<count($prows2); $k++) {
				$vmProdNameArr2[] = utf8_encode(htmlentities($prows2[$k]['product_name'], ENT_QUOTES));
				$vmProdDescArr2[] = utf8_encode(htmlentities(strip_tags(trim($prows2[$k]['product_s_desc'])), ENT_QUOTES));
				$vmProdPriceArr2[] = round($prows2[$k]['product_price'], 2); 					
				if(!empty($prows2[$k]['product_thumb_image'])) {
					$vmProdThumbArr2[] = JURI::root() . 'components/com_virtuemart/shop_image/product/' . $prows2[$k]['product_thumb_image'];				
				}
				else {
					$vmProdThumbArr2[] = JURI::root() . 'administrator/components/com_ivmstore/assets/images/noimage.jpg';
				}
				
			}		

		}

		$cid = JRequest::getVar('cid', array(), 'request', 'array');
		$qry = "SELECT * FROM #__ivm_app
				WHERE app_id = '{$cid[0]}'";
		$db->setQuery($qry);
		$db->query();
		$rows = $db->loadObjectList();

	
		HTML_Ivmstore::editstore($option, $rows, $vmCatNameArr, $vmCatDescArr, $vmCatThumbArr, $vmProdNameArr, $vmProdDescArr, $vmProdPriceArr, $vmProdThumbArr, $vmProdNameArr2, $vmProdDescArr2, $vmProdPriceArr2, $vmProdThumbArr2, $vmProdDetailName, $vmProdDetailDesc, $vmProdDetailPrice, $vmProdDetailImage, $vmCheckFlag);
	}

	function removestore() {
		$msgFlag = 0;
		$option = JRequest::getCmd('option');
		$db	=& JFactory::getDBO();
		$cid = JRequest::getVar('cid', array(), 'request', 'array');
		
		
		/*Upload Directories Iphone*/
		$uploadDirIphone = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'iphone' . DS . 'existingstores';
		
		/*Upload Directories Android*/
		$uploadDirAndroid = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'android' . DS . 'existingstores';

		foreach($cid AS $value) {
			$tmpQry = '';
			$tmpQry = "SELECT app_splash_screen_iphone, app_splash_screen_android, app_logo_iphone, app_logo_android, app_background_iphone, app_background_android, app_iphone_status, app_android_status, app_ipad_status
					FROM #__ivm_app
					WHERE app_id = '{$value}'";
			$db->setQuery($tmpQry);
			$db->query();
			$frow = $db->loadObjectList();
		
			$app_iphone_statusStr = $frow[0]->app_iphone_status;
			$app_android_statusStr = $frow[0]->app_android_status;
			$app_ipad_statusStr = $frow[0]->app_ipad_status;

			if($app_iphone_statusStr == 'N' && $app_android_statusStr == 'N' && $app_ipad_statusStr == 'N') {
				/*Old File Names*/
				$splashScreenIphoneStrFlagStr = $frow[0]->app_splash_screen_iphone;
				$splashScreenAndroidStrFlagStr = $frow[0]->app_splash_screen_android;
				$logoIphoneStrFlagStr = $frow[0]->app_logo_iphone;
				$logoAndroidStrFlagStr = $frow[0]->app_logo_android;
				$bgimgIphoneStrFlagStr = $frow[0]->app_background_iphone;
				$bgimgAndroidStrFlagStr = $frow[0]->app_background_android;

				unlink($uploadDirIphone . DS . $splashScreenIphoneStrFlagStr);
				unlink($uploadDirIphone . DS . $logoIphoneStrFlagStr);
				unlink($uploadDirIphone . DS . $bgimgIphoneStrFlagStr);
				
				unlink($uploadDirAndroid . DS . $splashScreenAndroidStrFlagStr);
				unlink($uploadDirAndroid . DS . $logoAndroidStrFlagStr);
				unlink($uploadDirAndroid . DS . $bgimgAndroidStrFlagStr);
		
				$delQry = "DELETE FROM #__ivm_app
							WHERE app_id = '{$value}'";

				$db->setQuery($delQry);
				$db->query();
			}
			else {
				$msgFlag = 1;
			}
		}
		
		$this->setRedirect('index.php?option=com_ivmstore&task=listhistory');

		if($msgFlag == 0) {
			$this->setMessage('Store Deleted Successfully');
		}
		else {
			$this->setMessage('Some Stores could not be deleted as they are having live apps');
		}
	}

	function iframe() {
		ob_clean();
		/*Image resizing class*/
		require_once(JPATH_COMPONENT.DS.'SimpleImage.php');
		$image = new SimpleImage();
		

		if(isset($_FILES['splash_screen'])) {
			
			$tempdir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'temp' . DS . 'addnewstore' . DS . 'splash_screen';

			$iphonedir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'iphone' . DS . 'addnewstore' . DS . 'splash_screen';
			$iphonehandle = opendir($iphonedir);
			while (false !== ($iphonefile = readdir($iphonehandle))) {
				
				if($iphonefile !== ".." && $iphonefile !== "." && $iphonefile !== "index.html" && $iphonefile !== "Thumbs.db") {
					unlink($iphonedir . DS . $iphonefile);
				}
			}

			$androiddir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'android' . DS . 'addnewstore' . DS . 'splash_screen';
			$androidhandle = opendir($androiddir);
			while (false !== ($androidfile = readdir($androidhandle))) {
				
				if($androidfile !== ".." && $androidfile !== "." && $androidfile !== "index.html" && $androidfile !== "Thumbs.db") {
					unlink($androiddir . DS . $androidfile);
				}
			}

			copy($_FILES['splash_screen']['tmp_name'], $tempdir . DS . $_FILES['splash_screen']['name']);

			$image->load($tempdir . DS . $_FILES['splash_screen']['name']);
			$image->resize(320,460);
			$image->save($tempdir . DS . $_FILES['splash_screen']['name'], $_FILES['splash_screen']['name'], $iphonedir, $androiddir);
		}

		if(isset($_FILES['logo'])) {
			
			$tempdir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'temp' . DS . 'addnewstore' . DS . 'logo';

			$iphonedir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'iphone' . DS . 'addnewstore' . DS . 'logo';
			$iphonehandle = opendir($iphonedir);
			while (false !== ($iphonefile = readdir($iphonehandle))) {
				
				if($iphonefile !== ".." && $iphonefile !== "." && $iphonefile !== "index.html" && $iphonefile !== "Thumbs.db") {
					unlink($iphonedir . DS . $iphonefile);
				}
			}

			$androiddir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'android' . DS . 'addnewstore' . DS . 'logo';
			$androidhandle = opendir($androiddir);
			while (false !== ($androidfile = readdir($androidhandle))) {
				
				if($androidfile !== ".." && $androidfile !== "." && $androidfile !== "index.html" && $androidfile !== "Thumbs.db") {
					unlink($androiddir . DS . $androidfile);
				}
			}

			copy($_FILES['logo']['tmp_name'], $tempdir . DS . $_FILES['logo']['name']);

			
			/*$image->load($tempdir . DS . $_FILES['logo']['name']);
			$image->resize(180,30);
			$image->save($tempdir . DS . $_FILES['logo']['name'], $_FILES['logo']['name'], $iphonedir, $androiddir);*/

			copy($tempdir . DS . $_FILES['logo']['name'], $iphonedir . DS . $_FILES['logo']['name']);
			copy($tempdir . DS . $_FILES['logo']['name'], $androiddir . DS . $_FILES['logo']['name']);
				
		}

		if(isset($_FILES['bgimg'])) {
			$tempdir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'temp' . DS . 'addnewstore' . DS . 'bgimg';

			$iphonedir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'iphone' . DS . 'addnewstore' . DS . 'bgimg';
			$iphonehandle = opendir($iphonedir);
			while (false !== ($iphonefile = readdir($iphonehandle))) {
				
				if($iphonefile !== ".." && $iphonefile !== "." && $iphonefile !== "index.html" && $iphonefile !== "Thumbs.db") {
					unlink($iphonedir . DS . $iphonefile);
				}
			}

			$androiddir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'android' . DS . 'addnewstore' . DS . 'bgimg';
			$androidhandle = opendir($androiddir);
			while (false !== ($androidfile = readdir($androidhandle))) {
				
				if($androidfile !== ".." && $androidfile !== "." && $androidfile !== "index.html" && $androidfile !== "Thumbs.db") {
					unlink($androiddir . DS . $androidfile);
				}
			}

			copy($_FILES['bgimg']['tmp_name'], $tempdir . DS . $_FILES['bgimg']['name']);

			
			$image->load($tempdir . DS . $_FILES['bgimg']['name']);
			$image->resize(320,460);
			$image->save($tempdir . DS . $_FILES['bgimg']['name'], $_FILES['bgimg']['name'], $iphonedir, $androiddir);
		}
	}

	function getfilecontent() {
		ob_clean();
		$fileid = $_REQUEST['fileid'];
		
		$subdirname = '';
		switch($fileid) {
			case 'splash_replace':
				$subdirname = 'splash_screen';
			break;
			case 'logo_replace':
				$subdirname = 'logo';
			break;

			case 'bgimg_replace':
				$subdirname = 'bgimg';
			break;
		}
		
		$sendString = '';

		$iphonedir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'iphone' . DS . 'addnewstore' . DS . $subdirname;

		$iphonehandle = opendir($iphonedir);
		while (false !== ($iphonefile = readdir($iphonehandle))) {
			
			if($iphonefile !== ".." && $iphonefile !== "." && $iphonefile !== "index.html" && $iphonefile !== "Thumbs.db") {
				$sendString .= JURI::root() . "administrator/components/com_ivmstore/uploads/iphone/addnewstore/" . $subdirname . "/" . $iphonefile;
				
			}
		}

		$androiddir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'android' . DS . 'addnewstore' . DS . $subdirname;
		
		/*Include Seperator*/
		$sendString .= '%%%%';

		$androidhandle = opendir($androiddir);
		while (false !== ($androidfile = readdir($androidhandle))) {
			
			if($androidfile !== ".." && $androidfile !== "." && $androidfile !== "index.html" && $androidfile !== "Thumbs.db") {
				$sendString .= JURI::root() . "administrator/components/com_ivmstore/uploads/android/addnewstore/" . $subdirname . "/" . $androidfile;
				
			}
		}
		
		echo $sendString;
		exit;
	}

	function reset_category_settings_images() {
		ob_clean();
		$iphonebgimgdir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'iphone' . DS . 'addnewstore' .DS . 'bgimg';

		$iphonebgimghandle = opendir($iphonebgimgdir);
		while (false !== ($iphonebgimgfile = readdir($iphonebgimghandle))) {
			if($iphonebgimgfile !== ".." && $iphonebgimgfile !== "." && $iphonebgimgfile !== "index.html" && $iphonebgimgfile !== "Thumbs.db") {
				unlink($iphonebgimgdir . DS . $iphonebgimgfile);
			}
		}

		$iphonelogodir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'iphone' . DS . 'addnewstore' .DS . 'logo';

		$iphonelogohandle = opendir($iphonelogodir);
		while (false !== ($iphonelogofile = readdir($iphonelogohandle))) {
			if($iphonelogofile !== ".." && $iphonelogofile !== "." && $iphonelogofile !== "index.html" && $iphonelogofile !== "Thumbs.db") {
				unlink($iphonelogodir . DS . $iphonelogofile);
			}
		}


		$androidbgimgdir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'android' . DS . 'addnewstore' .DS . 'bgimg';

		$androidbgimghandle = opendir($androidbgimgdir);
		while (false !== ($androidbgimgfile = readdir($androidbgimghandle))) {
			if($androidbgimgfile !== ".." && $androidbgimgfile !== "." && $androidbgimgfile !== "index.html" && $androidbgimgfile !== "Thumbs.db") {
				unlink($androidbgimgdir . DS . $androidbgimgfile);
			}
		}

		$androidlogodir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'android' . DS . 'addnewstore' .DS . 'logo';

		$androidlogohandle = opendir($androidlogodir);
		while (false !== ($androidlogofile = readdir($androidlogohandle))) {
			if($androidlogofile !== ".." && $androidlogofile !== "." && $androidlogofile !== "index.html" && $androidlogofile !== "Thumbs.db") {
				unlink($androidlogodir . DS . $androidlogofile);
			}
		}
		exit;
	}

	function reset_splashscreen() {
		ob_clean();
		$iphonesplash_screendir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'iphone' . DS . 'addnewstore' .DS . 'splash_screen';

		$iphonesplash_screenhandle = opendir($iphonesplash_screendir);
		while (false !== ($iphonesplash_screenfile = readdir($iphonesplash_screenhandle))) {
			if($iphonesplash_screenfile !== ".." && $iphonesplash_screenfile !== "." && $iphonesplash_screenfile !== "index.html" && $iphonesplash_screenfile !== "Thumbs.db") {
				unlink($iphonesplash_screendir . DS . $iphonesplash_screenfile);
			}
		}

		$androidsplash_screendir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'android' . DS . 'addnewstore' .DS . 'splash_screen';

		$androidsplash_screenhandle = opendir($androidsplash_screendir);
		while (false !== ($androidsplash_screenfile = readdir($androidsplash_screenhandle))) {
			if($androidsplash_screenfile !== ".." && $androidsplash_screenfile !== "." && $androidsplash_screenfile !== "index.html" && $androidsplash_screenfile !== "Thumbs.db") {
				unlink($androidsplash_screendir . DS . $androidsplash_screenfile);
			}
		} 
		echo 'ok';
		exit;
	}

	function savestore() {
		
		require_once(JPATH_COMPONENT . DS . 'ivmconstants.php');

		$option = JRequest::getCmd('option');
		
		$post = JRequest::get('post');
		
		$app_name = $post['app_name'];
		$app_theme = $post['app_theme'];
		$app_header_text = $post['app_header_text'];
		if($app_header_text == '') {
			switch($app_theme) {
				case 'black':
					$app_header_text = '#FFFFFF';
				break;
				
				case 'grey':
					$app_header_text = '#FEFEFE';
				break;

				case 'blue':
					$app_header_text = '#030500';
				break;

				case 'pink':
					$app_header_text = '#F4EEF3';
				break;
			}
		}


		$app_cat_text = $post['app_cat_text'];
		if($app_cat_text == '') {
			switch($app_theme) {
				case 'black':
					$app_cat_text = '#FFFFFF';
				break;
				case 'grey':
					$app_cat_text = '#525864';
				break;
				case 'blue':
					$app_cat_text = '#1143A9';
				break;
				case 'pink':
					$app_cat_text = '#BB4F8A';
				break;
			}
		}
		
		$app_cat_desc_color = $post['app_cat_desc_color'];
		if($app_cat_desc_color == '') {
			switch($app_theme) {
				case 'black':
					$app_cat_desc_color = '#C6C6C6';
				break;
				case 'grey':
					$app_cat_desc_color = '#515964';
				break;
				case 'blue':
					$app_cat_desc_color = '#000000';
				break;
				case 'pink':
					$app_cat_desc_color = '#091116';
				break;
			}
		}
		
		
		$app_cat_img = $post['app_cat_img'];
		$app_cat_desc = $post['app_cat_desc'];
		
		$app_prod_text = $post['app_prod_text'];
		if($app_prod_text == '') {
			switch($app_theme) {
				case 'black':
					$app_prod_text = '#FFFFFF';	
				break;
				case 'grey':
					$app_prod_text = '#525864';
				break;
				case 'blue':
					$app_prod_text = '#1143A9';
				break;
				case 'pink':
					$app_prod_text = '#BB4F8A';
				break;
			}
		}

		$app_prod_desc_toggle = $post['app_prod_desc_toggle'];
		
		$app_prod_desc = $post['app_prod_desc'];
		if($app_prod_desc == '') {
			switch($app_theme) {
				case 'black':
					$app_prod_desc = '#C6C6C6';
				break;
				case 'grey':
					$app_prod_desc = '#515964';
				break;
				case 'blue':
					$app_prod_desc = '#000000';
				break;
				case 'pink':
					$app_prod_desc = '#091116';
				break;
			}
		}

		$app_prod_price_text = $post['app_prod_price_text'];
		if($app_prod_price_text == '') {
			switch($app_theme) {
				case 'black':
					$app_prod_price_text = '#959595';	
				break;
				case 'grey':
					$app_prod_price_text = '#515862';
				break;
				case 'blue':
					$app_prod_price_text = '#797979';
				break;
				case 'pink':
					$app_prod_price_text = '#FEFEFD';
				break;
			}
		}


		$app_prod_primary_sort = $post['app_prod_primary_sort'];
		
		$app_prod_text2 = ($post['app_prod_text2'] !== '') ? $post['app_prod_text2'] : '#FFFFFF';
		$app_prod_desc2 = ($post['app_prod_desc2'] !== '') ? $post['app_prod_desc2'] : '#FFFFFF';
		$app_prod_price_text2 = ($post['app_prod_price_text2'] !== '') ? $post['app_prod_price_text2'] : '#FFFFFF';
		$app_related_prod_title_text = ($post['app_related_prod_title_text'] !== '') ? $post['app_related_prod_title_text'] : '#FFFFFF';
		$app_related_prod = $post['app_related_prod'];
		
		$db	=& JFactory::getDBO();

		$query = "INSERT INTO #__ivm_app
					(app_name, app_theme, app_header_text, app_cat_text, app_cat_img, app_cat_desc, app_cat_desc_color, app_prod_text, app_prod_desc_toggle, app_prod_desc, app_prod_primary_sort, app_prod_text2, app_prod_desc2, app_prod_price_text, app_prod_price_text2, app_related_prod_title_text, app_related_prod)
				  VALUES('{$app_name}', '{$app_theme}', '{$app_header_text}', '{$app_cat_text}', '{$app_cat_img}', '{$app_cat_desc}', '{$app_cat_desc_color}', '{$app_prod_text}', '{$app_prod_desc_toggle}', '{$app_prod_desc}', '{$app_prod_primary_sort}', '{$app_prod_text2}', '{$app_prod_desc2}', '{$app_prod_price_text}', '{$app_prod_price_text2}', '{$app_related_prod_title_text}', '{$app_related_prod}')";
		
		$db->setQuery($query);
		$db->query();
		
		$lastinsertid = $db->insertid();

		/*Upload Directories Iphone*/
		$uploadDirIphone = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'iphone' . DS . 'existingstores';
		
		/*Upload Directories Android*/
		$uploadDirAndroid = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'android' . DS . 'existingstores';

		/*Splash Screen Iphone*/
		$splashScreenIphoneStr = '';
		
		$iphone_splashscreen_dir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'iphone' . DS . 'addnewstore' . DS . 'splash_screen';

		$iphone_splashscreen_handle = opendir($iphone_splashscreen_dir);

		while (false !== ($iphone_splashscreen_file = readdir($iphone_splashscreen_handle))) {
			if($iphone_splashscreen_file !== ".." && $iphone_splashscreen_file !== "." && $iphone_splashscreen_file !== "index.html" && $iphone_splashscreen_file !== "Thumbs.db") {
				$splashScreenIphoneStr = md5(microtime().rand(0,999999)) . $iphone_splashscreen_file;
				copy($iphone_splashscreen_dir . DS . $iphone_splashscreen_file, $uploadDirIphone . DS . $splashScreenIphoneStr);

				unlink($iphone_splashscreen_dir . DS . $iphone_splashscreen_file);
			}
		}

		/*Splash Screen Android*/
		$splashScreenAndroidStr = '';

		$android_splashscreen_dir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'android' . DS . 'addnewstore' . DS . 'splash_screen';

		$android_splashscreen_handle = opendir($android_splashscreen_dir);

		while (false !== ($android_splashscreen_file = readdir($android_splashscreen_handle))) {
			if($android_splashscreen_file !== ".." && $android_splashscreen_file !== "." && $android_splashscreen_file !== "index.html" && $android_splashscreen_file !== "Thumbs.db") {
				$splashScreenAndroidStr = md5(microtime().rand(0,999999)) . $android_splashscreen_file;
				copy($android_splashscreen_dir . DS . $android_splashscreen_file, $uploadDirAndroid . DS . $splashScreenAndroidStr);

				unlink($android_splashscreen_dir . DS . $android_splashscreen_file);
			}
		}

		/*Logo Screen Iphone*/
		$logoIphoneStr = '';

		$iphone_logo_dir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'iphone' . DS . 'addnewstore' . DS . 'logo';

		$iphone_logo_handle = opendir($iphone_logo_dir);

		while (false !== ($iphone_logo_file = readdir($iphone_logo_handle))) {
			if($iphone_logo_file !== ".." && $iphone_logo_file !== "." && $iphone_logo_file !== "index.html" && $iphone_logo_file !== "Thumbs.db") {
				$logoIphoneStr = md5(microtime().rand(0,999999)) . $iphone_logo_file;
				copy($iphone_logo_dir . DS . $iphone_logo_file, $uploadDirIphone . DS . $logoIphoneStr);

				unlink($iphone_logo_dir . DS . $iphone_logo_file);
			}
		}

		/*Logo Screen Android*/
		$logoAndroidStr = '';

		$android_logo_dir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'android' . DS . 'addnewstore' . DS . 'logo';

		$android_logo_handle = opendir($android_logo_dir);

		while (false !== ($android_logo_file = readdir($android_logo_handle))) {
			if($android_logo_file !== ".." && $android_logo_file !== "." && $android_logo_file !== "index.html" && $android_logo_file !== "Thumbs.db") {
				$logoAndroidStr = md5(microtime().rand(0,999999)) . $android_logo_file;
				copy($android_logo_dir . DS . $android_logo_file, $uploadDirAndroid . DS . $logoAndroidStr);

				unlink($android_logo_dir . DS . $android_logo_file);
			}
		}

		/*Bgimg Screen Iphone*/
		$bgimgIphoneStr = '';

		$iphone_bgimg_dir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'iphone' . DS . 'addnewstore' . DS . 'bgimg';

		$iphone_bgimg_handle = opendir($iphone_bgimg_dir);

		while (false !== ($iphone_bgimg_file = readdir($iphone_bgimg_handle))) {
			if($iphone_bgimg_file !== ".." && $iphone_bgimg_file !== "." && $iphone_bgimg_file !== "index.html" && $iphone_bgimg_file !== "Thumbs.db") {
				$bgimgIphoneStr = md5(microtime().rand(0,999999)) . $iphone_bgimg_file;
				copy($iphone_bgimg_dir . DS . $iphone_bgimg_file, $uploadDirIphone . DS . $bgimgIphoneStr);

				unlink($iphone_bgimg_dir . DS . $iphone_bgimg_file);
			}
		}


		/*Bgimg Screen Android*/
		$bgimgAndroidStr = '';

		$android_bgimg_dir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'android' . DS . 'addnewstore' . DS . 'bgimg';

		$android_bgimg_handle = opendir($android_bgimg_dir);

		while (false !== ($android_bgimg_file = readdir($android_bgimg_handle))) {
			if($android_bgimg_file !== ".." && $android_bgimg_file !== "." && $android_bgimg_file !== "index.html" && $android_bgimg_file !== "Thumbs.db") {
				$bgimgAndroidStr = md5(microtime().rand(0,999999)) . $android_bgimg_file;
				copy($android_bgimg_dir . DS . $android_bgimg_file, $uploadDirAndroid . DS . $bgimgAndroidStr);

				unlink($android_bgimg_dir . DS . $android_bgimg_file);
			}
		}
		
		$updateQry = "UPDATE #__ivm_app
						SET app_splash_screen_iphone = '{$splashScreenIphoneStr}',
							app_splash_screen_android = '{$splashScreenAndroidStr}',
							app_logo_iphone = '{$logoIphoneStr}',
							app_logo_android = '{$logoAndroidStr}',
							app_background_iphone = '{$bgimgIphoneStr}',
							app_background_android = '{$bgimgAndroidStr}'
						WHERE app_id = '{$lastinsertid}'";
		$db->setQuery($updateQry);
		$db->query();

		$lastChangeQry = "UPDATE #__ivm_apppage
							SET lastchange  = NOW()";
		$db->setQuery($lastChangeQry);
		$db->query();

		if($_REQUEST['buynow'] == 'Y') {
			/*$this->setRedirect(BUY_NOW_URL . '&appname=' . $app_name . '&logourl=' . JURI::root() . 'administrator/components/com_ivmstore/uploads/iphone/existingstores/' . $logoIphoneStrFlagStr);*/
			$postlogourlStr = '';
			if(!empty($logoIphoneStrFlagStr)) {
				$postlogourlStr = JURI::root() . 'administrator/components/com_ivmstore/uploads/iphone/existingstores/' . $logoIphoneStrFlagStr;
			}
			ob_clean();
			?><form action="<?php echo BUY_NOW_URL; ?>" method="post" id="postivm">
				<input type="hidden" name="appname" value="<?php echo $app_name; ?>">
				<input type="hidden" name="logourl" value="<?php echo $postlogourlStr; ?>">
			</form>
			<script type="text/javascript">
				document.getElementById('postivm').submit();
			</script><?php
			exit;
		}
		else {
			$this->setRedirect('index.php?option=com_ivmstore');
		}

		$this->setMessage('Store Saved Successfully');
	}

	function editsavestore() {
		
		require_once(JPATH_COMPONENT . DS . 'ivmconstants.php');

		$option = JRequest::getCmd('option');
		
		$post = JRequest::get('post');
		
		$app_id = $post['app_id'];
		$app_name = $post['app_name'];
		$app_theme = $post['app_theme'];
		$app_header_text = ($post['app_header_text'] !== '') ? $post['app_header_text'] : '#000000';
		$app_cat_text = ($post['app_cat_text'] !== '') ? $post['app_cat_text'] : '#000000';
		$app_cat_desc_color = ($post['app_cat_desc_color'] !== '') ? $post['app_cat_desc_color'] : '#000000';
		$app_cat_img = $post['app_cat_img'];
		$app_cat_desc = $post['app_cat_desc'];
		
		$app_prod_text = ($post['app_prod_text'] !== '') ? $post['app_prod_text'] : '#000000';
		$app_prod_desc_toggle = $post['app_prod_desc_toggle'];
		$app_prod_desc = ($post['app_prod_desc'] !== '') ? $post['app_prod_desc'] : '#000000';
		$app_prod_price_text = ($post['app_prod_price_text'] !== '') ? $post['app_prod_price_text'] : '#000000';
		$app_prod_primary_sort = $post['app_prod_primary_sort'];
		
		$app_prod_text2 = ($post['app_prod_text2'] !== '') ? $post['app_prod_text2'] : '#000000';
		$app_prod_desc2 = ($post['app_prod_desc2'] !== '') ? $post['app_prod_desc2'] : '#000000';
		$app_prod_price_text2 = ($post['app_prod_price_text2'] !== '') ? $post['app_prod_price_text2'] : '#000000';
		$app_related_prod_title_text = ($post['app_related_prod_title_text'] !== '') ? $post['app_related_prod_title_text'] : '#ffffff';
		$app_related_prod = $post['app_related_prod'];

		$db	=& JFactory::getDBO();

		$query = "UPDATE #__ivm_app
					SET app_name = '{$app_name}',
					app_theme = '{$app_theme}',
					app_header_text = '{$app_header_text}',
					app_cat_text = '{$app_cat_text}',
					app_cat_img = '{$app_cat_img}',
					app_cat_desc = '{$app_cat_desc}',
					app_cat_desc_color = '{$app_cat_desc_color}',
					app_prod_text = '{$app_prod_text}',
					app_prod_desc_toggle = '{$app_prod_desc_toggle}',
					app_prod_desc = '{$app_prod_desc}',
					app_prod_primary_sort = '{$app_prod_primary_sort}',
					app_prod_text2 = '{$app_prod_text2}',
					app_prod_desc2 = '{$app_prod_desc2}',
					app_prod_price_text = '{$app_prod_price_text}',
					app_prod_price_text2 = '{$app_prod_price_text2}',
					app_related_prod_title_text = '{$app_related_prod_title_text}',
					app_related_prod = '{$app_related_prod}'
				WHERE app_id = '{$app_id}'";
		
		$db->setQuery($query);
		$db->query();


		/*Upload Directories Iphone*/
		$uploadDirIphone = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'iphone' . DS . 'existingstores';
		
		/*Upload Directories Android*/
		$uploadDirAndroid = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'android' . DS . 'existingstores';
		
		/*Flags*/
		$splashScreenIphoneStrFlag = 0;
		$splashScreenAndroidStrFlag = 0;
		$logoIphoneStrFlag = 0;
		$logoAndroidStrFlag = 0;
		$bgimgIphoneStrFlag = 0;
		$bgimgAndroidStrFlag = 0;

		/*Splash Screen Iphone*/
		$splashScreenIphoneStr = '';
		
		$iphone_splashscreen_dir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'iphone' . DS . 'addnewstore' . DS . 'splash_screen';

		$iphone_splashscreen_handle = opendir($iphone_splashscreen_dir);
		
		while (false !== ($iphone_splashscreen_file = readdir($iphone_splashscreen_handle))) {
			if($iphone_splashscreen_file !== ".." && $iphone_splashscreen_file !== "." && $iphone_splashscreen_file !== "index.html" && $iphone_splashscreen_file !== "Thumbs.db") {
				$splashScreenIphoneStr = md5(microtime().rand(0,999999)) . $iphone_splashscreen_file;
				copy($iphone_splashscreen_dir . DS . $iphone_splashscreen_file, $uploadDirIphone . DS . $splashScreenIphoneStr);
				$splashScreenIphoneStrFlag = 1;
				unlink($iphone_splashscreen_dir . DS . $iphone_splashscreen_file);
			}
		}

		/*Splash Screen Android*/
		$splashScreenAndroidStr = '';

		$android_splashscreen_dir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'android' . DS . 'addnewstore' . DS . 'splash_screen';

		$android_splashscreen_handle = opendir($android_splashscreen_dir);

		while (false !== ($android_splashscreen_file = readdir($android_splashscreen_handle))) {
			if($android_splashscreen_file !== ".." && $android_splashscreen_file !== "." && $android_splashscreen_file !== "index.html" && $android_splashscreen_file !== "Thumbs.db") {
				$splashScreenAndroidStr = md5(microtime().rand(0,999999)) . $android_splashscreen_file;
				copy($android_splashscreen_dir . DS . $android_splashscreen_file, $uploadDirAndroid . DS . $splashScreenAndroidStr);
				$splashScreenAndroidStrFlag = 1;
				unlink($android_splashscreen_dir . DS . $android_splashscreen_file);
			}
		}

		/*Logo Screen Iphone*/
		$logoIphoneStr = '';

		$iphone_logo_dir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'iphone' . DS . 'addnewstore' . DS . 'logo';

		$iphone_logo_handle = opendir($iphone_logo_dir);

		while (false !== ($iphone_logo_file = readdir($iphone_logo_handle))) {
			if($iphone_logo_file !== ".." && $iphone_logo_file !== "." && $iphone_logo_file !== "index.html" && $iphone_logo_file !== "Thumbs.db") {
				$logoIphoneStr = md5(microtime().rand(0,999999)) . $iphone_logo_file;
				copy($iphone_logo_dir . DS . $iphone_logo_file, $uploadDirIphone . DS . $logoIphoneStr);
				$logoIphoneStrFlag = 1;
				unlink($iphone_logo_dir . DS . $iphone_logo_file);
			}
		}

		/*Logo Screen Android*/
		$logoAndroidStr = '';

		$android_logo_dir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'android' . DS . 'addnewstore' . DS . 'logo';

		$android_logo_handle = opendir($android_logo_dir);

		while (false !== ($android_logo_file = readdir($android_logo_handle))) {
			if($android_logo_file !== ".." && $android_logo_file !== "." && $android_logo_file !== "index.html" && $android_logo_file !== "Thumbs.db") {
				$logoAndroidStr = md5(microtime().rand(0,999999)) . $android_logo_file;
				copy($android_logo_dir . DS . $android_logo_file, $uploadDirAndroid . DS . $logoAndroidStr);
				$logoAndroidStrFlag = 1;
				unlink($android_logo_dir . DS . $android_logo_file);
			}
		}

		/*Bgimg Screen Iphone*/
		$bgimgIphoneStr = '';

		$iphone_bgimg_dir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'iphone' . DS . 'addnewstore' . DS . 'bgimg';

		$iphone_bgimg_handle = opendir($iphone_bgimg_dir);

		while (false !== ($iphone_bgimg_file = readdir($iphone_bgimg_handle))) {
			if($iphone_bgimg_file !== ".." && $iphone_bgimg_file !== "." && $iphone_bgimg_file !== "index.html" && $iphone_bgimg_file !== "Thumbs.db") {
				$bgimgIphoneStr = md5(microtime().rand(0,999999)) . $iphone_bgimg_file;
				copy($iphone_bgimg_dir . DS . $iphone_bgimg_file, $uploadDirIphone . DS . $bgimgIphoneStr);
				$bgimgIphoneStrFlag = 1;
				unlink($iphone_bgimg_dir . DS . $iphone_bgimg_file);
			}
		}

		/*Bgimg Screen Android*/
		$bgimgAndroidStr = '';

		$android_bgimg_dir = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'uploads' . DS . 'android' . DS . 'addnewstore' . DS . 'bgimg';

		$android_bgimg_handle = opendir($android_bgimg_dir);

		while (false !== ($android_bgimg_file = readdir($android_bgimg_handle))) {
			if($android_bgimg_file !== ".." && $android_bgimg_file !== "." && $android_bgimg_file !== "index.html" && $android_bgimg_file !== "Thumbs.db") {
				$bgimgAndroidStr = md5(microtime().rand(0,999999)) . $android_bgimg_file;
				copy($android_bgimg_dir . DS . $android_bgimg_file, $uploadDirAndroid . DS . $bgimgAndroidStr);
				$bgimgAndroidStrFlag = 1;
				unlink($android_bgimg_dir . DS . $android_bgimg_file);
			}
		}

		$fileQry = "SELECT 	app_splash_screen_iphone, app_splash_screen_android, app_logo_iphone, app_logo_android, app_background_iphone, app_background_android
					FROM #__ivm_app
					WHERE app_id = '{$app_id}'";

		$db->setQuery($fileQry);
		$db->query();
		$frow = $db->loadObjectList();
		
		/*Old File Names*/
		$splashScreenIphoneStrFlagStr = $frow[0]->app_splash_screen_iphone;
		$splashScreenAndroidStrFlagStr = $frow[0]->app_splash_screen_android;
		$logoIphoneStrFlagStr = $frow[0]->app_logo_iphone;
		$logoAndroidStrFlagStr = $frow[0]->app_logo_android;
		$bgimgIphoneStrFlagStr = $frow[0]->app_background_iphone;
		$bgimgAndroidStrFlagStr = $frow[0]->app_background_android;

		if($splashScreenIphoneStrFlag == 1) {
			/*Delete old splash file*/
			unlink($uploadDirIphone . DS . $splashScreenIphoneStrFlagStr);
			$splashScreenIphoneStrFlagStr = $splashScreenIphoneStr;
		}
		if($splashScreenAndroidStrFlag == 1) {
			/*Delete old splash file*/
			unlink($uploadDirAndroid . DS . $splashScreenAndroidStrFlagStr);
			$splashScreenAndroidStrFlagStr = $splashScreenAndroidStr;
		}
		if($logoIphoneStrFlag == 1) {
			/*Delete old logo file*/
			unlink($uploadDirIphone . DS . $logoIphoneStrFlagStr);
			$logoIphoneStrFlagStr = $logoIphoneStr;
		}
		if($logoAndroidStrFlag == 1) {
			/*Delete old logo file*/
			unlink($uploadDirAndroid . DS . $logoAndroidStrFlagStr);
			$logoAndroidStrFlagStr = $logoAndroidStr;
		}
		if($bgimgIphoneStrFlag == 1) {
			/*Delete old background file*/
			unlink($uploadDirIphone . DS . $bgimgIphoneStrFlagStr);
			$bgimgIphoneStrFlagStr = $bgimgIphoneStr;
		}
		if($bgimgAndroidStrFlag == 1) {
			/*Delete old background file*/
			unlink($uploadDirAndroid . DS . $bgimgAndroidStrFlagStr);
			$bgimgAndroidStrFlagStr = $bgimgAndroidStr;
		}

		$updateFileQry = "UPDATE #__ivm_app
							SET app_splash_screen_iphone = '{$splashScreenIphoneStrFlagStr}',
							app_splash_screen_android = '{$splashScreenAndroidStrFlagStr}',
							app_logo_iphone = '{$logoIphoneStrFlagStr}',
							app_logo_android = '{$logoAndroidStrFlagStr}',
							app_background_iphone = '{$bgimgIphoneStrFlagStr}',
							app_background_android = '{$bgimgAndroidStrFlagStr}'
						WHERE app_id = '{$app_id}'";

		$db->setQuery($updateFileQry);
		$db->query();

		$lastChangeQry = "UPDATE #__ivm_apppage
							SET lastchange  = NOW()";
		$db->setQuery($lastChangeQry);
		$db->query();
		
		if($_REQUEST['buynow'] == 'Y') {
			/*$this->setRedirect(BUY_NOW_URL . '&appname=' . $app_name . '&logourl=' . JURI::root() . 'administrator/components/com_ivmstore/uploads/iphone/existingstores/' . $logoIphoneStrFlagStr);*/
			$postlogourlStr = '';
			if(!empty($logoIphoneStrFlagStr)) {
				$postlogourlStr = JURI::root() . 'administrator/components/com_ivmstore/uploads/iphone/existingstores/' . $logoIphoneStrFlagStr;
			}
			ob_clean();
			?><form action="<?php echo BUY_NOW_URL; ?>" method="post" id="postivm">
				<input type="hidden" name="appname" value="<?php echo $app_name; ?>">
				<input type="hidden" name="logourl" value="<?php echo $postlogourlStr; ?>">
			</form>
			<script type="text/javascript">
				document.getElementById('postivm').submit();
			</script><?php
			exit;
		}
		else {
			$this->setRedirect('index.php?option=com_ivmstore');
		}

		$this->setMessage('Store Edited Successfully');
	}

	function listhistory() {
		$option = JRequest::getCmd('option');
		$db	=& JFactory::getDBO();
		
		/*Update App Status*/
		/*$curl = curl_init();
		curl_setopt ($curl, CURLOPT_URL, JURI::root() . "check.php");
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl, CURLOPT_POST, 1);
		curl_setopt($curl, CURLOPT_POSTFIELDS, "check=" . '1|L|L|N/2|N|N|N');
		$result = curl_exec($curl);
		curl_close($curl);
		
		if($result !== 'No Apps found') {
			$appStatusArr = array();
			$appStatusArr = explode("/", $result);
			foreach($appStatusArr AS $value) {
				$tempArr = array();
				$tempArr = explode("|", $value);
				$query = "UPDATE #__ivm_app
							SET app_iphone_status = '{$tempArr[1]}',
								app_android_status = '{$tempArr[2]}',
								app_ipad_status = '{$tempArr[3]}'
							WHERE app_id = '{$tempArr[0]}'";
				$db->setQuery($query);
				$db->query();
			}
		}*/

		$db->setQuery("SELECT * FROM #__ivm_app ORDER BY app_creation_date DESC");
		$db->query();
		$rows = $db->loadObjectList();

		require_once(JPATH_COMPONENT.DS.'admin.ivmstore.html.php');
		HTML_Ivmstore::listhistory($option, $rows);
	}

	function listnotifications() {
		$option = JRequest::getCmd('option');
		$db	=& JFactory::getDBO();
		$db->setQuery("SELECT * FROM #__ivm_notifications");

		$db->query();
		$rows = $db->loadObjectList();

		require_once(JPATH_COMPONENT.DS.'admin.ivmstore.html.php');
		HTML_Ivmstore::listnotifications($option, $rows);
	}

	function addnewnotification() {
		$shopperGroupArr = array();
		$db	=& JFactory::getDBO();
		$shopperGroupQry = "SELECT shopper_group_id, shopper_group_name
							FROM #__vm_shopper_group";
		$db->setQuery($shopperGroupQry);
		$db->query();
		$rows = $db->loadObjectList();
		for($i=0; $i<count($rows); $i++) {
			$row = $rows[$i];
			$shopperGroupArr[$row->shopper_group_id] = $row->shopper_group_name;
		}
		
		require_once(JPATH_COMPONENT.DS.'admin.ivmstore.html.php');
		HTML_Ivmstore::addnewnotification($shopperGroupArr);
	}

	function savenotification() {
		$this->setRedirect('index.php?option=com_ivmstore&task=listnotifications');
		$post = JRequest::get('post');
		$nname = $post['nname'];
		$shopper_group = JRequest::getVar('shopper_group', array(), 'request', 'array');
		$ntext = $post['ntext'];
		$ndate = $post['ndate'];
		if($ndate == '') {
			$ndate = date('Y-m-d');
		}
		$start_hour = $post['start_hour'];
		$start_minute = $post['start_minute'];
		$send_now = $post['sendnow'];
	
		$shopper_group_arr = array();
		$shopper_group_arr = implode(",", $shopper_group);
		
		$ndateStr = $ndate . " " . $start_hour . ":" . $start_minute . ":" . "00";
		$db	=& JFactory::getDBO();

		if($send_now == 'N') {
			$query = "INSERT INTO #__ivm_notifications
						(nname, sgid, ntext, ndate, nstatus)
					  VALUES('{$nname}', '{$shopper_group_arr}', '{$ntext}', '{$ndateStr}', 'P')";
			$db->setQuery($query);
			$db->query();
		}
		else {
			$query = "INSERT INTO #__ivm_notifications
						(nname, sgid, ntext, ndate, nstatus)
					  VALUES('{$nname}', '{$shopper_group_arr}', '{$ntext}', NOW(), 'P')"; 
			$db->setQuery($query);
			$db->query();
		}

		$pushquery = "SELECT devicetoken FROM #__ivm_devicetoken";
		$db->setQuery($pushquery);
		$db->query();
		$rows = $db->loadObjectList();
		$curl = curl_init();
		curl_setopt ($curl, CURLOPT_URL, "http://sbcclothing.com/push/push.php");
		curl_setopt($curl, CURLOPT_POST, 1);
	
		for($i=0; $i<count($rows); $i++) {
			$row = $rows[$i];
			curl_setopt($curl, CURLOPT_POSTFIELDS, "devicetoken=" . $row->devicetoken . "&message=" . $ntext);
			curl_exec ($curl);
		}
		curl_close($curl);

		$this->setMessage('Notification Saved Successfully');
	}

	function pushnotification($deviceToken, $message) {
		// Put your private key's passphrase here:
		$passphrase = 'test123';
		$ctx = stream_context_create();
		stream_context_set_option($ctx, 'ssl', 'local_cert', JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'ivmwebservices' .DS . 'apns-dev.pem');
		stream_context_set_option($ctx, 'ssl', 'passphrase', $passphrase);

		// Open a connection to the APNS server
		$fp = stream_socket_client('ssl://gateway.sandbox.push.apple.com:2195', $err, $errstr, 60, STREAM_CLIENT_CONNECT|STREAM_CLIENT_PERSISTENT, $ctx);

		// Create the payload body
		$body['aps'] = array('alert' => $message, 'sound' => 'default');

		// Encode the payload as JSON
		$payload = json_encode($body);

		// Build the binary notification
		$msg = chr(0) . pack('n', 32) . pack('H*', $deviceToken) . pack('n', strlen($payload)) . $payload;

		// Send it to the server
		$result = fwrite($fp, $msg, strlen($msg));
		
		// Close the connection to the server
		fclose($fp);
	}

	function editnotification() {
		
		$option = JRequest::getCmd('option');
		$db	=& JFactory::getDBO();
		$cid = JRequest::getVar('cid', array(), 'request', 'array');
		$qry = "SELECT * FROM #__ivm_notifications
				WHERE nid = '{$cid[0]}'";
		$db->setQuery($qry);
		$db->query();
		$rows = $db->loadObjectList();

		$shopperGroupArr = array();
		
		$shopperGroupQry = "SELECT shopper_group_id, shopper_group_name
							FROM #__vm_shopper_group";
		$db->setQuery($shopperGroupQry);
		$db->query();
		$srows = $db->loadObjectList();
		for($i=0; $i<count($srows); $i++) {
			$srow = $srows[$i];
			$shopperGroupArr[$srow->shopper_group_id] = $srow->shopper_group_name;
		}

		require_once(JPATH_COMPONENT.DS.'admin.ivmstore.html.php');
		HTML_Ivmstore::editnotification($option, $rows, $shopperGroupArr);

	}

	function editsavenotification() {
		$this->setRedirect('index.php?option=com_ivmstore&task=listnotifications');
		$post = JRequest::get('post');
		$nid = $post['nid'];
		$nname = $post['nname'];
		$shopper_group = JRequest::getVar('shopper_group', array(), 'request', 'array');
		$ntext = $post['ntext'];
		$ndate = $post['ndate'];
		if($ndate == '') {
			$ndate = date('Y-m-d');
		}
		$start_hour = $post['start_hour'];
		$start_minute = $post['start_minute'];
		$send_now = $post['sendnow'];
	
		$shopper_group_arr = array();
		$shopper_group_arr = implode(",", $shopper_group);
		
		$ndateStr = $ndate . " " . $start_hour . ":" . $start_minute . ":" . "00";
		$db	=& JFactory::getDBO();

		if($send_now == 'N') {
			$query = "UPDATE #__ivm_notifications
						SET nname = '{$nname}',
							sgid = '{$shopper_group_arr}',
							ntext = '{$ntext}',
							ndate = '{$ndateStr}'
						WHERE nid = '{$nid}'";
			$db->setQuery($query);
			$db->query();
		}
		else {
			$query = "UPDATE #__ivm_notifications
						SET nname = '{$nname}',
							sgid = '{$shopper_group_arr}',
							ntext = '{$ntext}',
							ndate = NOW()
						WHERE nid = '{$nid}'";
			$db->setQuery($query);
			$db->query();
		}

		$pushquery = "SELECT devicetoken FROM #__ivm_devicetoken";
		$db->setQuery($pushquery);
		$db->query();
		$rows = $db->loadObjectList();
		$curl = curl_init();
		curl_setopt ($curl, CURLOPT_URL, "http://sbcclothing.com/push/push.php");
		curl_setopt($curl, CURLOPT_POST, 1);
	
		for($i=0; $i<count($rows); $i++) {
			$row = $rows[$i];
			curl_setopt($curl, CURLOPT_POSTFIELDS, "devicetoken=" . $row->devicetoken . "&message=" . $ntext);
			curl_exec ($curl);
		}
		curl_close($curl);

		$this->setMessage('Notification Saved Successfully');
	}

	function removenotification() {
		$this->setRedirect('index.php?option=com_ivmstore&task=listnotifications');

		$db	=& JFactory::getDBO();
		$cid = JRequest::getVar('cid', array(), 'request', 'array');
		foreach($cid AS $value) {
			$delQry = "DELETE FROM #__ivm_notifications
							WHERE nid = '{$value}'";

			$db->setQuery($delQry);
			$db->query();
		}

		$this->setMessage('Notification Deleted Successfully');
	}

	function frontlook() {
		ob_clean();
		?><link href="<?php echo JURI::root() . 'administrator/components/com_ivmstore/assets/css/ivmstore.css'; ?>" rel="stylesheet" type="text/css" />
		<div class="main_view">
		<link rel="stylesheet" type="text/css" href="../css/ivmstore.css" />
		<div class="window">
			<div id="image_reel" class="image_reel">
				<div class="ivmComposerBlock2">
					<div id="" class="iphone">
						<div class="ivmfirstscreen">
							<iframe width="217" style="overflow:hidden;" frameborder="0" height="313" src="<?php echo JURI::root(); ?>" frameborder="0" allowfullscreen></iframe>
						</div>
					</div>
				</div>
				<div class="ivmComposerBlock3">
					<div class="android">
						<div class="ivmsecondscreen">
							<iframe width="195" style="overflow:hidden;" frameborder="0" height="295" src="<?php echo JURI::root(); ?>" frameborder="0" allowfullscreen></iframe>			
						</div>
					</div>
				</div>
			</div>
		</div>
	</div><?php
		exit;
	}

	function saveivmfile() {
		$this->setRedirect('index.php?option=com_ivmstore');
		$this->setMessage('iVM File Generated Successfully');

		
		if(is_dir(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_virtuemart')) {
			
			$db =& JFactory::getDBO();
			$fp = fopen(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'ivmfields.txt', 'w');
			fwrite($fp, "iVM Fields (iVM Compozer has been installed using Virtuemart AIO)" . "\r\n");
			fwrite($fp, "==========" . "\r\n\r\n");

			/*Site Details*/
			fwrite($fp, "Site Details" . "\r\n");
			fwrite($fp, "============" . "\r\n");
			/*Site Name*/
			fwrite($fp, "Site URL : " . JURI::root() . "\r\n");

			/*Joomla Version*/
			fwrite($fp, "Joomla Version : " . JVERSION  . "\r\n");

			/*Primary Language*/
			$lang =& JFactory::getLanguage();
			fwrite($fp, "Primary Language : " . $lang->getTag() . "\r\n");

			/*Other Languages*/
			$langArr = array();
			$langStr = 'None';
			$langdir = scandir(JPATH_SITE . DS . 'language');
			foreach($langdir as $object) {
				if ($object !== "." && $object !== ".." && $object !== $lang->getTag()) {
					if (filetype(JPATH_SITE . DS . 'language' . DS . $object) == "dir") {
						if($object !== 'pdf_fonts') {
							$langArr[] = $object;	
						}
					}
				}
			}

			if(count($langArr) > 0) {
				$langStr = implode(",", $langArr);
			}
			fwrite($fp, "Other Languages : " . $langStr . "\r\n");
			fwrite($fp, "\r\n\r\n");

			/*Virtuemart details*/
			fwrite($fp, "Virtuemart Details" . "\r\n");
			fwrite($fp, "==================" . "\r\n");
			/*Virtuemart version*/
			include_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_virtuemart' . DS . 'version.php');
			fwrite($fp, "Virtuemart Version : " . $VMVERSION->RELEASE . "\r\n");

			/*Subcategory Check*/
			$subCategoryCheck = "No";
			$subCategoryQry = "SELECT category_parent_id, category_child_id 
						FROM #__vm_category_xref";
			$db->setQuery($subCategoryQry);
			$subCategoryRows = $db->loadAssocList();
			for($i=0; $i<count($subCategoryRows); $i++) {
				if((int)$subCategoryRows[$i]['category_parent_id'] !== 0) {
					$subCategoryCheck = "Yes";
					break;
				}
			}
			fwrite($fp, "Are there any sub-categories? : " . $subCategoryCheck . "\r\n");

			/*Sub Category Level Start*/
			global $subCatLevelArr;
			global $previousCatArr;

			$rootCatArr = array();
			$rootCatQry = "SELECT category_child_id
					FROM #__vm_category_xref
					WHERE category_parent_id = 0";
			$db->setQuery($rootCatQry);
			$rootCatRows = $db->loadAssocList();
			for($i=0; $i<count($rootCatRows); $i++) {
				$rootCatArr[] = $rootCatRows[$i]['category_child_id'];
			}

			foreach($rootCatArr AS $rootCatId) {
				$subCatLevelArr[$rootCatId] = 0;
				IvmstoreController::recursiveSubcatLevel($rootCatId, $rootCatId);
				
				$result = array_unique($previousCatArr);
				
				$finalArr = array();
				foreach($result AS $temp) {
					foreach($previousCatArr AS $val) {
						if($temp == $val) {
							$finalArr[$temp]++;	
						}
					}
				}
				
				foreach($finalArr AS $key => $valu) {
					if($finalArr[$key] > 1) {
						$subCatLevelArr[$rootCatId]--;
					}
				}
				$previousCatArr = array();
			}

			$subCatLevelAns = 0;
			if(count($subCatLevelArr) > 0) {
				$subCatLevelAns = max($subCatLevelArr) + 1;
			}
			fwrite($fp, "Maximum Number of Sub-categories level : " . $subCatLevelAns . "\r\n");

			/*Sub Category Level End*/

			/*Child Product Check*/
			$childProductChkStr = "No";
			$childProductChkQry = "SELECT product_id
						FROM #__vm_product
						WHERE product_parent_id != 0";
			$db->setQuery($childProductChkQry);
			$childProductChkRows = $db->loadAssocList();
			if(count($childProductChkRows) > 0) {
				$childProductChkStr = "Yes";
			}
			fwrite($fp, "Are there any child products? : " . $childProductChkStr . "\r\n");

			/*Normal Attribute Check*/
			$normalAttrStr = "No";
			$attrCountQry = "SELECT attribute FROM #__vm_product";
			$db->setQuery($attrCountQry);
			$attrCountRows = $db->loadAssocList();

			for($i=0; $i<count($attrCountRows); $i++) {
				if($attrCountRows[$i]['attribute'] !== "") {
					$normalAttrStr = "Yes";
					break;
				}
			}
			fwrite($fp, "Are there any Normal attributes? : " . $normalAttrStr . "\r\n");


			/*Maximum Number of Normal attribute*/
			$finalAttrCountArr = array();
			$finalAttrCountArr[] = 0;
			for($i=0; $i<count($attrCountRows); $i++) {
				if($attrCountRows[$i]['attribute'] !== "") {
					$tempArr = array();
					$tempArr = explode(";", $attrCountRows[$i]['attribute']);
					$finalAttrCountArr[] = count($tempArr);
				}
			}
			fwrite($fp, "Maximum Number of Normal Attributes : " .max($finalAttrCountArr) . "\r\n");


			/*Custom Attribute Check*/
			$finalCustomAttrCntArr = array(); 
			$finalCustomAttrCntArr[] = 0;
			$customAttrStr = "No"; 
			$customAttrQry = "SELECT custom_attribute FROM #__vm_product";
			$db->setQuery($customAttrQry);
			$customAttrRows = $db->loadAssocList();
			for($i=0; $i<count($customAttrRows); $i++) {
				if($customAttrRows[$i]['custom_attribute'] !== '') {
					$customAttrStr = "Yes";
					break;
				}
			}
			fwrite($fp, "Are there any custom attributes? : " . $customAttrStr . "\r\n");


			/*Maximum number of custom attributes*/
			for($i=0; $i<count($customAttrRows); $i++) {
				if($customAttrRows[$i]['custom_attribute'] !== "") {
					$tempArr = array();
					$tempArr = explode(";", $customAttrRows[$i]['custom_attribute']);
					$finalCustomAttrCntArr[] = count($tempArr);
				}
			}
			fwrite($fp, "Maximum Number of Custom Attributes : " . max($finalCustomAttrCntArr) . "\r\n");


			/*Shipping Methods List*/
			$shippingModuleListArr = array();
			include_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_virtuemart' . DS . 'virtuemart.cfg.php');
			for($i=0; $i<50; $i++) {
				if(isset($PSHOP_SHIPPING_MODULES[$i])) {
					$shippingModuleListArr[] = $PSHOP_SHIPPING_MODULES[$i];
				}
				else {
					break;
				}
			}
			fwrite($fp, "What shipping Methods are used in the site? : " . implode(",", $shippingModuleListArr) . "\r\n");


			/*JoomFish Check*/
			$joomFishChkStr = "No";
			if(is_dir(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_joomfish') || is_dir(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_joomfishplus')) {
				$joomFishChkStr = "Yes";
			}
			fwrite($fp, "Has it got data coming via Joomfish? : " . $joomFishChkStr . "\r\n");

			/*Guest Checkout Check*/
			$guestChkoutChk = "No";
			if(VM_REGISTRATION_TYPE == 'NO_REGISTRATION') {
				$guestChkoutChk = "Yes";
			}
			fwrite($fp, "Is Guest checkout allowed? : " . $guestChkoutChk . "\r\n");

			/*Payment Methods List*/
			$paymentMethodQry = "SELECT * 
						FROM #__vm_payment_method
						WHERE payment_enabled = 'Y'";
			$db->setQuery($paymentMethodQry);
			$paymentMethodRows = $db->loadAssocList();
			for($i=0; $i<count($paymentMethodRows); $i++) {
				fwrite($fp, "Payment Method Used " . ($i+1) . " : Id(" . $paymentMethodRows[$i]['payment_method_id'] . ") " . $paymentMethodRows[$i]['payment_method_name'] . "\r\n");	
			}

			fwrite($fp, "\r\n\r\n");

			/*Store and Vendor Details*/
			$storeQry = "SELECT * 
					FROM #__vm_vendor
					WHERE vendor_id = 1";
			$db->setQuery($storeQry);
			$storerows = $db->loadAssocList();
			fwrite($fp, "Vendor Details" . "\r\n");
			fwrite($fp, "==============" . "\r\n");
			fwrite($fp, "Store Owner Name : " . $storerows[0]['contact_title'] . " " . $storerows[0]['contact_first_name'] . " " . $storerows[0]['contact_middle_name'] . " " . $storerows[0]['contact_last_name'] . "\r\n");
			fwrite($fp, "Vendor Name : " . $storerows[0]['vendor_name'] . "\r\n");
			fwrite($fp, "Vendor Phone 1 : " . $storerows[0]['contact_phone_1'] . "\r\n");
			fwrite($fp, "Vendor Phone 2 : " . $storerows[0]['contact_phone_2'] . "\r\n");
			fwrite($fp, "Vendor Fax : " . $storerows[0]['contact_fax'] . "\r\n");
			fwrite($fp, "Vendor Email : " . $storerows[0]['contact_email'] . "\r\n");
			fwrite($fp, "Vendor Phone : " . $storerows[0]['vendor_phone'] . "\r\n");
			fwrite($fp, "Vendor Address 1 : " . $storerows[0]['vendor_address_1'] . "\r\n");
			fwrite($fp, "Vendor Address 2 : " . $storerows[0]['vendor_address_2'] . "\r\n");
			fwrite($fp, "Vendor City : " . $storerows[0]['vendor_city'] . "\r\n");
			fwrite($fp, "Vendor State : " . $storerows[0]['vendor_state'] . "\r\n");
			fwrite($fp, "Vendor Country : " . $storerows[0]['vendor_country'] . "\r\n");
			fwrite($fp, "Vendor Zip : " . $storerows[0]['vendor_zip'] . "\r\n");
			fwrite($fp, "Vendor Store Name : " . $storerows[0]['vendor_store_name'] . "\r\n");
			fwrite($fp, "Vendor Store Currency : " . $storerows[0]['vendor_currency'] . "\r\n");
			fwrite($fp, "Vendor URL : " . $storerows[0]['vendor_url'] . "\r\n");
			fwrite($fp, "\r\n\r\n");
			fclose($fp);
			
			/*Download Txt File*/
			$size = filesize(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'ivmfields.txt');
			if(ini_get('zlib.output_compression')) {
				ini_set('zlib.output_compression', 'Off');
			}

			header("Content-type: application/force-download");
			header('Content-Disposition: attachment; filename="ivmfile.txt"');
			header("Content-Transfer-Encoding: binary");
			header('Accept-Ranges: bytes');
			header("Cache-control: private");
			header('Pragma: private');
			header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
			header("Content-Length: ".$size);
			readfile(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'ivmfields.txt');
			unlink(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_ivmstore' . DS . 'ivmfields.txt');
			exit();

		}
		else {
			$this->setMessage('Virtuemart installation not found');
		}
	}


	function recursiveSubcatLevel($rootCatId, $subCatId) {
		$db	=& JFactory::getDBO();
		global $subCatLevelArr;
		global $previousCatArr;
		
		$subCatQry = "SELECT category_child_id
				FROM #__vm_category_xref
				WHERE category_parent_id = " . $subCatId; 
		$db->setQuery($subCatQry);
		$subCatRows = $db->loadAssocList();
		
		if(count($subCatRows) > 0) {
			
			$subQ = "SELECT category_parent_id 
					FROM #__vm_category_xref
					WHERE category_child_id	= " . $subCatId;
			$db->setQuery($subQ);
			$subQRows = $db->loadAssocList();
			$previousCatArr[] =  $subQRows[0]['category_parent_id'];
			
			$subCatLevelArr[$rootCatId]++;

			for($i=0; $i<count($subCatRows); $i++) {
				IvmstoreController::recursiveSubcatLevel($rootCatId, $subCatRows[$i]['category_child_id']);		
			}
		}	
	}
}
