<?php
/**
* @package iVM Store
* @version 2.0
* @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Joomla! is free software and parts of it may contain or be derived from the
* GNU General Public License or other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

defined('_JEXEC') or die('Restricted Access');

class HTML_Ivmstore {
	
	function dashboard($addFlag, $editId, $version_text, $support_text, $resource_1_title, $resource_1_link, $resource_1_text, $resource_2_title, $resource_2_link, $resource_2_text, $resource_3_title, $resource_3_link, $resource_3_text, $resource_4_title, $resource_4_link, $resource_4_text) {
		//JPATH_COMPONENT.DS.'assets'.DS.'images'.DS.'ivmgeneric.png'
		JToolBarHelper::title('iVM Compozer', 'config.png');
		JToolBarHelper::cancel();
		require_once(JPATH_COMPONENT . DS . 'views' . DS . 'dashboard.html.php');
	}

	function addnewstore($vmCatNameArr, $vmCatDescArr, $vmCatThumbArr, $vmProdNameArr, $vmProdDescArr, $vmProdPriceArr, $vmProdThumbArr, $vmProdNameArr2, $vmProdDescArr2, $vmProdPriceArr2, $vmProdThumbArr2, $vmProdDetailName, $vmProdDetailDesc, $vmProdDetailPrice, $vmProdDetailImage, $vmCheckFlag) {
		JToolBarHelper::title('iVM Compozer - New App', 'config.png');
		JToolBarHelper::custom('savestore', 'save', 'save', 'Save', false, false);
		JToolBarHelper::cancel();
		if($vmCheckFlag == 'Y') {
			//require_once(JPATH_COMPONENT . DS . 'views' . DS . 'addnewstorevm.html.php');
			require_once(JPATH_COMPONENT . DS . 'views' . DS . 'addnewstore.html.php');
		}
		else {
			require_once(JPATH_COMPONENT . DS . 'views' . DS . 'addnewstore.html.php');
		}
	}

	function listhistory($option, &$rows) {
		JToolBarHelper::title('iVM Existing Designs', 'config.png');
		JToolBarHelper::custom('', 'help', 'dashboard', 'Home', false, false);
		JToolBarHelper::addNew('addnewstore', 'New');
		JToolBarHelper::editList('edit','Edit');
		JToolBarHelper::deleteList('', 'removestore','Delete');
		JToolBarHelper::cancel();
		require_once(JPATH_COMPONENT . DS . 'views' . DS . 'listhistory.html.php');
	}

	function editstore($option, &$rows, $vmCatNameArr, $vmCatDescArr, $vmCatThumbArr, $vmProdNameArr, $vmProdDescArr, $vmProdPriceArr, $vmProdThumbArr, $vmProdNameArr2, $vmProdDescArr2, $vmProdPriceArr2, $vmProdThumbArr2, $vmProdDetailName, $vmProdDetailDesc, $vmProdDetailPrice, $vmProdDetailImage, $vmCheckFlag) {
		JToolBarHelper::title('iVM Compozer - Edit App', 'config.png');
		JToolBarHelper::custom('editsavestore', 'save', 'save', 'Save', false, false);
		JToolBarHelper::cancel();
		if($vmCheckFlag == 'Y') {
			//require_once(JPATH_COMPONENT . DS . 'views' . DS . 'editstorevm.html.php');		
			require_once(JPATH_COMPONENT . DS . 'views' . DS . 'editstore.html.php');		
		}
		else {
			require_once(JPATH_COMPONENT . DS . 'views' . DS . 'editstore.html.php');		
		}
	}

	function submitsupport() {
		JToolBarHelper::title('iVM Support Page', 'config.png');
		JToolBarHelper::custom('savesupport', 'save', 'save', 'Save', false, false);
		JToolBarHelper::cancel();
		require_once(JPATH_COMPONENT . DS . 'ivmconstants.php');
		require_once(JPATH_COMPONENT . DS . 'views' . DS . 'submitsupport.html.php');
	}

	function apppage(&$rows) {
		JToolBarHelper::title('iVM App page settings', 'config.png');
		JToolBarHelper::custom('saveapppage', 'save', 'save', 'Save', false, false);
		JToolBarHelper::cancel();
		require_once(JPATH_COMPONENT . DS . 'views' . DS . 'apppage.html.php');
	}

	function listnotifications($option, &$rows){
		JToolBarHelper::title('iVM Notifications', 'config.png');
		JToolBarHelper::addNew('addnewnotification', 'New');
		JToolBarHelper::editList('editnotification','Edit');
		JToolBarHelper::deleteList('', 'removenotification','Delete');
		JToolBarHelper::cancel();
		require_once(JPATH_COMPONENT . DS . 'views' . DS . 'listnotifications.html.php');
	}

	function addnewnotification($shopperGroupArr) {
		JToolBarHelper::title('iVM Notifications - New', 'config.png');
		JToolBarHelper::cancel('listnotifications', 'Cancel');
		require_once(JPATH_COMPONENT . DS . 'views' . DS . 'addnewnotification.html.php');
	}

	function editnotification($option, &$rows, $shopperGroupArr) {
		JToolBarHelper::title('iVM Notifications - Edit', 'config.png');
		JToolBarHelper::cancel('listnotifications', 'Cancel');
		require_once(JPATH_COMPONENT . DS . 'views' . DS . 'editnotification.html.php');
	}
}
