CREATE TABLE IF NOT EXISTS `#__ivm_app` (
  `app_id` int(11) NOT NULL auto_increment,
  `app_name` varchar(255) NOT NULL,
  `app_splash_screen_iphone` varchar(255) NOT NULL,
  `app_splash_screen_android` varchar(255) NOT NULL,
  `app_logo_iphone` varchar(255) NOT NULL,
  `app_logo_android` varchar(255) NOT NULL,
  `app_background_iphone` varchar(255) NOT NULL,
  `app_background_android` varchar(255) NOT NULL,
  `app_theme` varchar(255) NOT NULL default 'black',
  `app_header_text` varchar(255) NOT NULL default '#000000',
  `app_cat_text` varchar(255) NOT NULL default '#000000',
  `app_cat_img` char(1) NOT NULL default 'Y',
  `app_cat_desc` char(1) NOT NULL default 'Y',
  `app_cat_desc_color` varchar(255) NOT NULL default '#000000',
  `app_prod_text` varchar(255) NOT NULL default '#000000',
  `app_prod_desc_toggle` char(1) NOT NULL default 'Y',
  `app_prod_desc` varchar(255) NOT NULL default '#000000',
  `app_prod_primary_sort` char(1) NOT NULL default 'P',
  `app_prod_text2` varchar(255) NOT NULL default '#000000',
  `app_prod_desc2` varchar(255) NOT NULL default '#000000',
  `app_prod_price_text` varchar(255) NOT NULL default '#000000',
  `app_prod_price_text2` varchar(255) NOT NULL default '#000000',
  `app_related_prod_title_text` varchar(255) NOT NULL default '#ffffff',
  `app_related_prod` char(1) NOT NULL default 'Y',
  `app_iphone_status` char(1) NOT NULL default 'N',
  `app_android_status` char(1) NOT NULL default 'N',
  `app_ipad_status` char(1) NOT NULL default 'N',
  `app_creation_date` datetime NOT NULL,
  PRIMARY KEY  (`app_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `#__ivm_apppage` (
  `download_id` varchar(255) NOT NULL,
  `uid` varchar(255) NOT NULL, 	
  `set_app_page` char(1) NOT NULL default 'N',
  `app_page_title` varchar(255) NOT NULL,
  `app_meta_description` varchar(255) NOT NULL,
  `app_meta_keywords` varchar(255) NOT NULL,
  `app_meta_robots` varchar(255) NOT NULL,
  `app_meta_author` varchar(255) NOT NULL,
  `app_meta_generator` varchar(255) NOT NULL,
  `app_iphone_link` varchar(255) NOT NULL,
  `app_ipad_link` varchar(255) NOT NULL,
  `app_android_link` varchar(255) NOT NULL,
  `lastchange` datetime NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


INSERT INTO `#__ivm_apppage` (`download_id`, `uid`, `set_app_page`, `app_page_title`, `app_meta_description`, `app_meta_keywords`, `app_meta_robots`, `app_meta_author`, `app_meta_generator`, `app_iphone_link`, `app_ipad_link`, `app_android_link`, `lastchange`) VALUES('test', 62, 'N', '', '', '', '', '', '', '', '', '', '0000-00-00 00:00:00');


CREATE TABLE IF NOT EXISTS `#__ivm_support` (
  `id` int(11) NOT NULL auto_increment,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `#__ivm_notifications` (
  `nid` int(11) NOT NULL auto_increment,
  `nname` varchar(255) NOT NULL,
  `sgid` varchar(255) NOT NULL,
  `ntext` text NOT NULL,
  `ndate` datetime NOT NULL,
  `nstatus` char(1) NOT NULL,
  PRIMARY KEY  (`nid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `#__ivm_devicetoken` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `devicetoken` varchar(255) NOT NULL,
  `dtime` datetime NOT NULL,	
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

