<?php
/**
* @package iVM Store
* @version 2.0
* @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Joomla! is free software and parts of it may contain or be derived from the
* GNU General Public License or other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

JSubMenuHelper::addEntry('Home', 'index.php?option=com_ivmstore');
JSubMenuHelper::addEntry('New Store', 'index.php?option=com_ivmstore&task=addnewstore');
JSubMenuHelper::addEntry('App Page', 'index.php?option=com_ivmstore&task=apppage');
JSubMenuHelper::addEntry('Support', 'index.php?option=com_ivmstore&task=submitsupport');
?><form action="index.php" method="post" name="adminForm" enctype="multipart/form-data">
	<table class="adminlist">
		<thead>
			<tr>
				<th width="20"><input type="checkbox" name="toggle" value=""  onclick="checkAll(<?php echo count( $rows ); ?>);" /></th>
				<th nowrap="nowrap" class="title"><?php echo "App Name"; ?></th>
				<th nowrap="nowrap" class="title"><?php echo "Iphone App"; ?></th>
				<th nowrap="nowrap" class="title"><?php echo "Android App"; ?></th>
				<th nowrap="nowrap" class="title"><?php echo "Ipad App"; ?></th>
			</tr>
		</thead>
		<tbody><?php
			$k = 0;
			for($i=0, $n=count( $rows ); $i < $n; $i++) {
				$row = &$rows[$i];
				$checked = JHTML::_('grid.id', $i, $row->app_id);
				$link = 'index.php?option=' . $option . '&task=edit&cid[]='. $row->app_id;
				$rowTemp  = 'row'.$k;
				?><tr class="<?php echo $rowTemp; ?>">
					<td align="center"><?php 
						echo $checked; 
					?></td>
					<td align="center"><?php
						echo $row->app_name;
					?></td>
					<td align="center"><?php
						if($row->app_iphone_status == 'P') {
							echo "Pending";
						}
						elseif($row->app_iphone_status == 'S') {
							echo "Submitted";
						}
						elseif($row->app_iphone_status == 'L') {
							echo "Live";
						}
						else {
							echo "Not Submitted";
						}
					?></td>
					<td align="center"><?php
						if($row->app_android_status == 'P') {
							echo "Pending";
						}
						elseif($row->app_android_status == 'S') {
							echo "Submitted";
						}
						elseif($row->app_android_status == 'L') {
							echo "Live";
						}
						else {
							echo "Not Submitted";
						}
					?></td>
					<td align="center"><?php
						if($row->app_ipad_status == 'P') {
							echo "Pending";
						}
						elseif($row->app_ipad_status == 'S') {
							echo "Submitted";
						}
						elseif($row->app_ipad_status == 'L') {
							echo "Live";
						}
						else {
							echo "Not Submitted";
						}
					?></td>
					
				</tr><?php
				$k = 1 - $k;
			}
		?></tbody>
	</table>
	<input type="hidden" name="option" value="<?php echo $option; ?>" />
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="boxchecked" value="0" />
</form>